# HandyNotes: Dragonflight Treasures

A [HandyNotes](https://www.curseforge.com/wow/addons/handynotes) plugin to show the Dragonflight treasure items and rares on your map. (That means it **requires** [HandyNotes](https://www.curseforge.com/wow/addons/handynotes), so go install it as well.)

This includes:

* Items in treasure chests
* Items dropped by rare mobs
* Dragon Glyphs
* [Ley Line in the Span](https://www.wowhead.com/achievement=16638/ley-line-in-the-span)
* [Who's A Good Bakar?](https://www.wowhead.com/achievement=16424/whos-a-good-bakar)
* [The Highest Peaks](https://www.wowhead.com/achievement=15890/dragonscale-expedition-the-highest-peaks)
* [Symbols of Hope](https://www.wowhead.com/achievement=16584/symbols-of-hope)
* Hidden-away quests for nifty things like the [Divine Kiss of Ohn'ahra](https://www.wowhead.com/item=198821/divine-kiss-of-ohnahra) and [Lizi's Reins](https://www.wowhead.com/item=192799/lizis-reins)
* ...and everything tucked away in the Dracthyr intro experience

Items that you've already collected and mobs you've already killed won't be displayed. This uses the "flag" quests that the game relies on to keep track of the items. Sometimes these glitch; generally if they do so, you also won't have gotten achievement-credit / the item, so you'll likely still be interested in the item.

You can right-click on any treasure node and hide it, if you just don't want to see that one. If you have [TomTom](https://www.curseforge.com/wow/addons/tomtom) installed, you can also add a waypoint for that node.

To edit the settings, visit the HandyNotes config panel, expand the "Plugins" section, and click on "Dragonflight". You can then choose which treasures to show, and whether to show ones you've already found.

## Want to help?

If you'd like to submit corrections, please go into the settings as mentioned above and turn on "show quest ids". Then let me know the quest id for the node you want to correct, which will now appear in its tooltip.

If you'd like to submit a new node, you have two options:

1. Tell me where it is. I'll go find it eventually and track down the more obscure details I need to add it.
1. Gather these details yourself and send them to me:
    * Zone and coordinates.
    * What it gives you.
    * The quest id associated with it. This is the tricky one. The easiest way to get it is to install [QuestsChanged](https://www.wowace.com/addons/questschanged/) before you open the treasure, then open the treasure and check it to see what quest was triggered.

## What else might help me find things?

* [Handy Minimap Arrow](https://www.curseforge.com/wow/addons/handy-minimap-arrow) will make your player-arrow on the minimap appear *above* all the notes I'm adding to it
* [What's On The Map?](https://www.curseforge.com/wow/addons/whats-on-the-map) will show a list of the vignettes currently up nearby
* [Minimap Range Extender](https://www.curseforge.com/wow/addons/minimap-range-extender) will make map vignettes visible from further away

If you have any problems, please use the [issues](https://github.com/kemayo/wow-handynotes-dragonflight/issues/new) link -- Curseforge's comments are genuinely bad at for quickly notifying me of anything.
