# v3.5.1

## Changes

Updated for prepatch phase 2.

### Checkmark

Awarded items now also has a checkmark overlay on their session button.

## Bugfixes

- *Fixed error when clicking buttons in the options menu.*

# v3.5.0

## Changes

### Dragonflight

Updated for Dragonflight prepatch.

Added token and trinket data.

Added auto pass for Evokers.

### Add all tradeable items to session

It's now possible to add all items from your bags with a trade timer on them to a session at once.
Simply use `/rc add bags` or `/rc add all` to do so. You must obviously still be ML/group leader to do so, and have the addon active.

### TradeUI

Updated logic being ItemStorage when trading items. It should now properly account for whom you're trading items to, which resolves issues with the "wrong" item being removed after trading with someone.

Last I checked there were still some issues with detecting the trade target (not sure I can do anything about it). The above will only work if trade target is detected properly, i.e. if the addon can add items to the trade window automatically.

### Group Loot

Addon now fully supports group loot. In this first iteration it more or less works similar to personal loot - although you may come across needing to manually add items (`/rc add [item]`). This will be expanding upon and more fletched out in the coming weeks.

### Other

Added `itemName` to JSON export (CurseClassic#137).


## Bugfixes

- *Frames will no longer intercept mouse scrolls when hidden (CurseClassic#181).*


# v3.4.0

## Changes

Updated for patch 9.2.7.

Non-tradeable items that's ignored or blacklisted are no longer recorded in the loot history (#210).

Added option for restoring `/rc` to its ready check functionality (#215, Curse#495).

### Dev

- *Added itemLink to `RCMLAwardSuccess` and `RCMLAwardFailed` AceEvents.*

## Bugfixes

- *Fixed issue with Auto Award BoE list. (Curse#500)*
- *Fixed occasional missing data error. (Curse#503)*
- *Fixed hyperlink formats in TSV exports - thanks to Yttrium-tYcLief (#214).*
- *Added `id` to json export (Classic#43).*
- *Award Later items now remembers which boss they where dropped by (Classic#43).*


# v3.3.0

## Changes 

### Patch 9.2

Updated for patch 9.2.0.

Re-added Armor Token button/response group option.
Added item data for Sepulcher of the First Ones.

## Bugfixes

- *Fixed issue with `/rc remove` command.*
- *TradeUI can now handle duplicate items.*

# v3.2.1

## Changes

### Patch 9.1.5

Updated for patch 9.1.5.

## Bugfixes

- _Fixed issue with non ascii name comparisons for never seen before players._

# v3.2.0

## Changes

### Patch 9.1

Updated for patch 9.1.

Added new trinkets to the auto pass list.

### Quality of life

Frames that have been manually minimized will no longer maximize when leaving combat.

Frame z-level issues are no longer a thing. Credits to enajork (#206).

Session frame no longer has items infinitely stuck on "Waiting for item info". Items are removed if the item info isn't found.

Added trinkets from all Shadowlands dungeons and raids to the auto pass list.

### Misc

`/rc fulltest` now always uses items from the latest raid. Credits to jjholleman (#204).

`/rc add` can now only be used supported inputs (itemLinks and itemIDs).

## Bugfixes

- _Session data didn't transmit properly after a disconnect/reload during a session (Curse#475)._

# 3.1.5

## Changes

Updated toc for patch 9.0.5.

# v3.1.4

## Bugfixes

- _A candidates mainhand/offhand is now always shown in the voting frame when dealing with context tokens. (Curse#470)_
- _Hopefully fixed the remaining issues plaguing the addon the last couple of weeks. (Curse#457-472)_

# v3.1.3

## Bugfixes

- _Suppressed errors in Voting Frame. Exact cause is still unknown, and this fix while supressing errors can still lead to blank spaces in voting frame. Please report back if you're experiencing any of this. (Curse#457-465)_

# v3.1.2

## Bugfixes

- _Context tokens were unintentionally ignored._
- _Fixed errors from missing functions (Curse#453)._
- _Council should now be more reliably sent before first kill to avoid non showing voting frame for council members (Curse#456, #202)._
- _Sorting of the default buttons in the voting frame now works again. Note you may need to move buttons up/down to properly register. (#203)._

# v3.1.1

## Bugfixes

- _Fixed issue with Blizzard functions occasionally returning nil upon entering a group (Curse#452)._
- _Fixed issue related to player classes (Curse#449)._

# v3.1.0

## Changes

### Auto Awards

Auto Awards now works on a priority based list, so that you can have fallbacks in case your usual recipient is on an alt etc.

The input field is updated to handle multiple entries at once (seperated by commas and/or spaces) when ungrouped, while still listing group members when grouped.

Candidates in the list have class icons and colors added if you've seen them recently. If they're in your group but don't have the class infomation, then you probably have misspelled their name.

All stored Auto Award settings has been reset as part of the update.

### Anima

Anima is no longer registered in the voting frame or history, and any anima in the history has been removed.

## Added

### Companion Pets

Pets now have a button group.

Added option to ignore all pets when looting.

### Version Check

The version checks now shows the totals of installed versions.

## Bugfixes

- _Players' enchating level again shows up in the disenchant menu in the voting frame._
- _The list of candidates now updates much more frequently to avoid listing candidates that have left the group._
- _Fixed corrupted player caches, introduced in v3.0.2, leading to a total breakdown (Curse#443-448 + #201)._

# v3.0.2

## Bugfixes

- _Group version checks could break the addon._
- _Cancelling the session frame while a session was running led to unexpected behaviors._
- _Fixed issue with guild ranks that could break the voting frame._

# v3.0.1

## Changes

Updated for patch 9.0.2.

### Version Check

Version check now again works cross realm.  
Players using older versions will have unexpected entries added if someone with this version performs a version check - that was unavoidable to make this work, but doesn't happen once you've upgraded.

## Bugfixes

- _The version checker wouldn't always show installed modules._
- _Fixed issues with adding cross realm council members leading to the entire addon to break._
- _Having an outdated version will no longer produce an error and correctly show a message prompting you to upgrade._

### Dev

- _Added recipient at index 6 for `VERSION.fr` comms._

# v3.0.0

_v3.0 is not backwards compatible with any older versions, including most of its beta versions._

## Changes

v3.0 marks a development landmark more than 2 years in the making.  
It consists of more than 10k line changes, most of which are background stuff you won't be seeing, with the goal of providing a solid foundation for the future.
Ideally you shouldn't _see_ any major changes, but everything should _feel_ faster and more responsive.  
Below is a list of the most relevant changes.

### Updated for Shadowlands

- Deprecated API calls have been removed, and all addon code updated for the changes introduced in Shadowlands.
- Shadowlands related dates have been added to the History Patch Mass delete tool.

#### Button Groups

- Added a new response group for Anima Beads and Spherules - a new Main/Off-hand token in Shadowlands.
- Removed the groups for Corruption.

### Comms overhaul

All comms have been updated with a new system compressing all messages sent.  
Most comms have been optimized resulting in up to an 90% decrease in comms usage, i.e. everything is faster.  
This change breaks backwards compatiblity with 2.x versions.

### Options Menu

The options menu have been slimmed down, some toggles have had a name switch and some options moved around.

#### Removed

The following have been removed and are now always enabled:

- Alt-click looting
- Loot Everything
- Notes
- Save Bonus Rolls
- Autoloot All BoE (merged with `Auto Add BoEs`)

#### Renamed

The following have had a name and description update to better explain what they do:

- Auto Start > Skip Session Frame
- Auto Loot > Auto Add Items
- Autoloot BoE > Auto Add BoE's

### Testing

v3.0 is developed with a philosophy of writing automated tests for all new code.  
This should result in a lot fewer bugs in new releases.  
The internal log has also been updated for better identifying issues.

### Removed

- Corruption column.
- `winners` command - has been handled by the TradeUI for a long time.

### Dev

- All comms have updated prefixes, commands, and handlers. Refer to `/Classes/Services/Comms.lua`.
- Old way of logging is removed - see `/Classes/Utils/Log.lua` for new implementation.
- Many structures now have their own files and classes. See `/Classes`.
- Classes are loaded with `RCLootCouncil.Require`. See `/Classes/Core.lua` for details.
- Removed all references to `candidates`. It's now based on `Player` class, and group members can be found with `RCLootCouncil.candidatesInGroup` and `RCLootCouncil:GroupIterator()`.
- `RCLootCouncil.council` removed. `db.profile.council` now stores GUIDs, which combined with `Data.Player` and `Data.Council` now makes up a council.

## Bugfixes

- _The completion indicator in the Synchronizer no longer disappears._
