-- Locale
local AceLocale = LibStub:GetLibrary("AceLocale-3.0");
local AL = AceLocale:NewLocale("RareScanner", "enUS", true, true);

if AL then
	AL["ALARM_MESSAGE"] = "A rare NPC just showed up, check your map!"
	AL["ALARM_SOUND"] = "Warning sound for rare NPCs"
	AL["ALARM_SOUND_DESC"] = "Sound played when a rare NPC shows up in your minimap"
	AL["ALARM_TREASURES_SOUND"] = "Warning sound for events/treasures"
	AL["ALARM_TREASURES_SOUND_DESC"] = "Sound played when a treasure/chest or event shows up in your minimap"
	AL["ALL_ZONES"] = "- All -"
	AL["APPLY_COLLECTIONS_LOOT_FILTERS"] = "Do you want to modify the loot displayed in the loot bar and world map so that it only shows the missing collections found? This will override your current loot filters (this doesn't apply to individual filters)."
	AL["AUTO_HIDE_BUTTON"] = "Autohide button and miniature"
	AL["AUTO_HIDE_BUTTON_DESC"] = "Hides the button and the miniature automatically after the time selected (in seconds). If you select zero seconds the button and the miniature won't autohide"
	AL["CHANNEL_AMBIENCE"] = "Ambience"
	AL["CHANNEL_DIALOG"] = "Dialog"
	AL["CHANNEL_MASTER"] = "Master"
	AL["CHANNEL_MUSIC"] = "Music"
	AL["CHANNEL_SFX"] = "SFX"
	AL["CLASS_HALLS"] = "Class Halls"
	AL["CLEAR_FILTERS_SEARCH"] = "Clear"
	AL["CLEAR_FILTERS_SEARCH_DESC"] = "Resets the form to the initial state"
	AL["CLICK_TARGET"] = "Click to target NPC"
	AL["CMD_DISABLE_ALERTS"] = "RareScanner rare NPCs, treasures and events alerts disabled"
	AL["CMD_DISABLE_CONTAINERS_ALERTS"] = "RareScanner treasures alerts disabled"
	AL["CMD_DISABLE_EVENTS_ALERTS"] = "RareScanner events alerts disabled"
	AL["CMD_DISABLE_RARES_ALERTS"] = "RareScanner rare NPCs alerts disabled"
	AL["CMD_DISABLE_SCANNING_WORLDMAP_VIGNETTES"] = "RareScanner scanning world map vignettes disabled"
	AL["CMD_ENABLE_ALERTS"] = "RareScanner rare NPCs, treasures and events alerts enabled"
	AL["CMD_ENABLE_CONTAINERS_ALERTS"] = "RareScanner treasures alerts enabled"
	AL["CMD_ENABLE_EVENTS_ALERTS"] = "RareScanner events alerts enabled"
	AL["CMD_ENABLE_RARES_ALERTS"] = "RareScanner rare NPCs alerts enabled"
	AL["CMD_ENABLE_SCANNING_WORLDMAP_VIGNETTES"] = "RareScanner scanning world map vignettes enabled"
	AL["CMD_HELP1"] = "List of commands"
	AL["CMD_HELP10"] = "Enable/disable scanning world map vignettes"
	AL["CMD_HELP11"] = "Show/hide icons of dragon glyphs on the world map"
	AL["CMD_HELP12"] = "Open RareScanner's explorer"
	AL["CMD_HELP2"] = "Show/hide all the icons on the world map"
	AL["CMD_HELP3"] = "Show/hide icons of events on the world map"
	AL["CMD_HELP4"] = "Show/hide icons of treasures on the world map"
	AL["CMD_HELP5"] = "Show/hide icons of rare NPCs on the world map"
	AL["CMD_HELP6"] = "Enable/disable all the alerts"
	AL["CMD_HELP7"] = "Enable/disable events alerts"
	AL["CMD_HELP8"] = "Enable/disable treasures alerts"
	AL["CMD_HELP9"] = "Enable/disable rare NPCs alerts"
	AL["CMD_HIDE"] = "Hiding RareScanner icons in the world map"
	AL["CMD_HIDE_DRAGON_GLYPHS"] = "Hiding RareScanner dragon glyphs icons on the world map"
	AL["CMD_HIDE_EVENTS"] = "Hiding RareScanner event icons in the world map"
	AL["CMD_HIDE_RARES"] = "Hiding RareScanner rare icons in the world map"
	AL["CMD_HIDE_TREASURES"] = "Hiding RareScanner treasure icons in the world map"
	AL["CMD_SHOW"] = "Showing RareScanner icons in the world map"
	AL["CMD_SHOW_DRAGON_GLYPHS"] = "Showing RareScanner dragon glyphs icons on the world map"
	AL["CMD_SHOW_EVENTS"] = "Showing RareScanner event icons in the world map"
	AL["CMD_SHOW_RARES"] = "Showing RareScanner rare icons in the world map"
	AL["CMD_SHOW_TREASURES"] = "Showing RareScanner treasure icons in the world map"
	AL["COLLECTION_FILTERS_PROFILE_BACKUP_CREATED"] = "Created a new profile based on the current one named %s."
	AL["CONTAINER"] = "Container"
	AL["CONTAINER_FILTER"] = "Container filters"
	AL["CUSTOM_NPC_ADD_NPC"] = "NPC ID"
	AL["CUSTOM_NPC_ADD_NPC_DESC"] = "Introduce the NPC ID and hit enter to add a new custom NPC. The NPC ID is a unique number that identifies a NPC in World of Warcraft. You can find these identification numbers on Wowhead or similar websites."
	AL["CUSTOM_NPC_ADD_NPC_EXISTS_RS"] = "The NPC is already supported by RareScanner."
	AL["CUSTOM_NPC_ADD_NPC_NOEXIST"] = "The NPC ID introduced couldn't be found. Sometimes the server takes a while to return its information, so try again and if the error persists verify that the ID is correct."
	AL["CUSTOM_NPC_ADD_ZONE"] = "Add zone"
	AL["CUSTOM_NPC_ADD_ZONE_DESC"] = "Adds this zone to the list of zones where you can find this NPC."
	AL["CUSTOM_NPC_COORDINATES"] = "Coordinates"
	AL["CUSTOM_NPC_COORDINATES_DESC"] = "(Optional) Coordinates where the NPC can spawn. Introduce the coordinates with the next format: X1-Y1,X2-Y2,.... For example: 0614-6712,75152-4123 (means that the NPC can spawn at the coordinates '6.14-67.12' and '75.152-41.23'). The skull will appear in your map at the first set of coordinates. The rest of coordinates will be used in the overlay layer."
	AL["CUSTOM_NPC_CURRENT_ZONE"] = "Zone"
	AL["CUSTOM_NPC_CURRENT_ZONE_DESC"] = "Zone where you can find this NPC."
	AL["CUSTOM_NPC_CURRENT_ZONES"] = "Zones where you can find this NPC"
	AL["CUSTOM_NPC_DELETE_NPC"] = "Delete this NPC"
	AL["CUSTOM_NPC_DELETE_NPC_CONFIRM"] = "Are you sure you want to delete '%s' from your custom NPCs list?"
	AL["CUSTOM_NPC_DELETE_NPC_DESC"] = "Deletes this custom NPC from the database."
	AL["CUSTOM_NPC_DELETE_ZONE"] = "Delete zone"
	AL["CUSTOM_NPC_DELETE_ZONE_CONFIRM"] = "Are you sure you want to delete this zone and its coordinates from the list of zones where you can find this NPC?"
	AL["CUSTOM_NPC_DELETE_ZONE_DESC"] = "Deletes this zone from the list of zones where you can find this NPC."
	AL["CUSTOM_NPC_DISPLAY_ID"] = "Display ID"
	AL["CUSTOM_NPC_DISPLAY_ID_DESC"] = "(Optional) The display ID is a unique number that identifies the model of a NPC. It is used to display the miniature of the NPC on top of the button whenever its found. You can find this identification number on Wowhead or similar websites."
	AL["CUSTOM_NPC_EXTRA_INFO"] = "Optional extra information"
	AL["CUSTOM_NPC_FIND_ZONES"] = "Select a zone where you can find this NPC"
	AL["CUSTOM_NPC_INFO"] = "Warning: The NPC won't be recorded until you add a zone."
	AL["CUSTOM_NPC_LOOT"] = "Loot"
	AL["CUSTOM_NPC_LOOT_DESC"] = "(Optional) Item IDs of the loot dropped by this NPC. Introduce the item IDs with the next format: ID1,ID2,.... For example: 184198,184198. You can find these identification numbers on Wowhead or similar websites."
	AL["CUSTOM_NPC_TEXT"] = "Important: RareScanner scans for custom NPC using their nameplates, so don't forget to enable them or you won't get alerts for them."
	AL["CUSTOM_NPC_VALIDATION_CHAR"] = "The value introduced contains characters different from '%s'"
	AL["CUSTOM_NPC_VALIDATION_COORD"] = "The coordinates introduced are incorrect. The string should have this format: X1-Y1,X2-Y2,..."
	AL["CUSTOM_NPC_VALIDATION_ITEM"] = "The item IDs introduced are incorrect. The string should have this format: ID1,ID2,..."
	AL["CUSTOM_NPC_VALIDATION_NUMBER"] = "The value introduced has to be a number."
	AL["CUSTOM_NPCS"] = "Custom NPCs"
	AL["CYPHER_CONSOLE"] = "Cypher Console"
	AL["CYPHER_CONSOLE_ENTRANCE"] = "Entrance to [Cypher Console]"
	AL["DATABASE_HARD_RESET"] = "Since the most recent expansion and with the last version of RareScanner big changes have occurred in the database, which required a database reset in order to avoid inconsistencies. Sorry for the inconvenience."
	AL["DISABLE_OBJECTS_SOUND"] = "Disable audio alerts with treasures and events"
	AL["DISABLE_OBJECTS_SOUND_DESC"] = "When this is activated you won't receive audio alerts with treasures and events"
	AL["DISABLE_SEARCHING_CONTAINER_TOOLTIP"] = "Disable alerts for this container"
	AL["DISABLE_SEARCHING_EVENT_TOOLTIP"] = "Disable alerts for this event"
	AL["DISABLE_SEARCHING_RARE_TOOLTIP"] = "Disable alerts for this rare NPC"
	AL["DISABLE_SOUND"] = "Disable audio alerts with NPCs"
	AL["DISABLE_SOUND_DESC"] = "When this is activated you won't receive audio alerts with NPCs"
	AL["DISABLED_SEARCHING_CONTAINER"] = "Disabled alerts for this container: %s"
	AL["DISABLED_SEARCHING_EVENT"] = "Disabled alerts for this event: %s"
	AL["DISABLED_SEARCHING_RARE"] = "Disabled alerts for this rare NPC: "
	AL["DISPLAY"] = "Display"
	AL["DISPLAY_BUTTON"] = "Toggle showing the button and the miniature"
	AL["DISPLAY_BUTTON_CONTAINERS"] = "Toggle showing the button for treasures/chests"
	AL["DISPLAY_BUTTON_CONTAINERS_DESC"] = "Toggle showing the button for treasures/chests. It doesn't affect the alarm sound and the chat alerts"
	AL["DISPLAY_BUTTON_DESC"] = "When disabled the button and the miniature won't be shown again. It doesn't affect the alarm sound and the chat alerts"
	AL["DISPLAY_BUTTON_SCALE"] = "Scale of the button and miniature"
	AL["DISPLAY_BUTTON_SCALE_DESC"] = "This will adjust the scale of the button and miniature, being the value of 0.85 the original size"
	AL["DISPLAY_BUTTON_SCALE_POSITION"] = "Scale and position options"
	AL["DISPLAY_CONTAINER_ICONS"] = "Toggle showing container icons on the world map"
	AL["DISPLAY_CONTAINER_ICONS_DESC"] = "When disabled, icons of containers/treasures won't be shown on the world map."
	AL["DISPLAY_EVENT_ICONS"] = "Toggle showing event icons on the world map"
	AL["DISPLAY_EVENT_ICONS_DESC"] = "When disabled, icons of events won't be shown on the world map."
	AL["DISPLAY_FRIENDLY_NPC_ICONS"] = "Toggle showing friendly rare NPC icons on the world map"
	AL["DISPLAY_FRIENDLY_NPC_ICONS_DESC"] = "When disabled, icons of friendly rare NPCs won't be shown on the world map."
	AL["DISPLAY_LOOT_PANEL"] = "Toggle showing loot bar"
	AL["DISPLAY_LOOT_PANEL_DESC"] = "When this is activated it will show a bar with the loot dropped by the NPC found"
	AL["DISPLAY_MAP_DRAGON_GLYPHS_ICONS"] = "Toggle showing dragon glyphs icons on the world map"
	AL["DISPLAY_MAP_DRAGON_GLYPHS_ICONS_DESC"] = "When disabled, icons of dragon glyphs won't be shown on the world map."
	AL["DISPLAY_MAP_NOT_DISCOVERED_ICONS"] = "Toggle showing not discovered icons on the map."
	AL["DISPLAY_MAP_NOT_DISCOVERED_ICONS_DESC"] = "When disabled, icons of not discovered rare NPCs (the red and orange icons), containers or events won't be shown on the world map"
	AL["DISPLAY_MAP_OLD_NOT_DISCOVERED_ICONS"] = "Toggle showing not discovered icons on the map for older expansions."
	AL["DISPLAY_MAP_OLD_NOT_DISCOVERED_ICONS_DESC"] = "When disabled, icons of not discovered rare NPCs (the red and orange icons), containers or events won't be shown on the world map for areas that belong to older expansions."
	AL["DISPLAY_MINIATURE"] = "Toggle showing the miniature"
	AL["DISPLAY_MINIATURE_DESC"] = "When disabled the miniature won't be shown again."
	AL["DISPLAY_MINIMAP_BUTTON"] = "Toggle showing the minimap button"
	AL["DISPLAY_MINIMAP_BUTTON_DESC"] = "Shows a button beside the minimap to access RareScanner explorer and the options panel"
	AL["DISPLAY_MINIMAP_ICONS"] = "Toggle icons in the minimap"
	AL["DISPLAY_MINIMAP_ICONS_DESC"] = "When disabled you won't see icons in the minimap."
	AL["DISPLAY_NPC_ICONS"] = "Toggle showing rare NPC icons on the world map"
	AL["DISPLAY_NPC_ICONS_DESC"] = "When disabled, icons of rare NPCs won't be shown on the world map."
	AL["DISPLAY_OPTIONS"] = "Display options"
	AL["DISPLAY_WORLDMAP_BUTTON"] = "Toggle showing the worldmap button"
	AL["DISPLAY_WORLDMAP_BUTTON_DESC"] = "Shows a button in the worldmap to access RareScanner options related with the worldmap"
	AL["DRAGON_GLYPH"] = "Dragon Glyphs"
	AL["DUNGEONS_SCENARIOS"] = "Dungeons/Scenarios"
	AL["ENABLE_AUTO_TOMTOM_WAYPOINTS"] = "Enable auto replacing waypoints"
	AL["ENABLE_AUTO_TOMTOM_WAYPOINTS_DESC"] = "When enabled as soon as you find an entity, the addon will replace your current Tomtom waypoints with a new one pointing to the recently entity found. When disabled a waypoint will be added only when clicking on the main button."
	AL["ENABLE_AUTO_WAYPOINTS"] = "Enable auto replacing waypoints"
	AL["ENABLE_AUTO_WAYPOINTS_DESC"] = "When enabled, as soon as you find an entity, the addon will replace your current ingame waypoint with a new one pointing to the recently found entity. When disabled a waypoint will be added only when clicking on the main button."
	AL["ENABLE_MARKER"] = "Toggle target marker"
	AL["ENABLE_MARKER_DESC"] = "When this is activated it will show a marker on top of the target when you click the main button"
	AL["ENABLE_SCAN_CHAT"] = "Toggle searching for rare NPCs through chat messages"
	AL["ENABLE_SCAN_CHAT_DESC"] = "When this is activated you will be warned visually and with a sound everytime a rare NPC yells or a chat message related with a rare NPCs is detected."
	AL["ENABLE_SCAN_CONTAINERS"] = "Toggle searching treasures or chests"
	AL["ENABLE_SCAN_CONTAINERS_DESC"] = "When this is activated you will be warned visually and with a sound everytime a treasure or chest shows up in your minimap"
	AL["ENABLE_SCAN_EVENTS"] = "Toggle searching events"
	AL["ENABLE_SCAN_EVENTS_DESC"] = "When this is activated you will be warned visually and with a sound everytime an event shows up in your minimap"
	AL["ENABLE_SCAN_GARRISON_CHEST"] = "Toggle searching garrison treasure"
	AL["ENABLE_SCAN_GARRISON_CHEST_DESC"] = "When this is activated you will be warned visually and with a sound everytime your garrison chest shows up in your minimap"
	AL["ENABLE_SCAN_IN_INSTANCE"] = "Toggle scanning in instances"
	AL["ENABLE_SCAN_IN_INSTANCE_DESC"] = "When this is activated the addon will work as usual while you are in an instance (dungeon, raid, etc)"
	AL["ENABLE_SCAN_ON_PET_BATTLE"] = "Toggle scanning while in pet battle"
	AL["ENABLE_SCAN_ON_PET_BATTLE_DESC"] = "When this is activated the addon will work as usual while you are in a pet battle"
	AL["ENABLE_SCAN_ON_TAXI"] = "Toggle scanning while using a transportation"
	AL["ENABLE_SCAN_ON_TAXI_DESC"] = "When this is activated the addon will work as usual while you are using a transportation (flight, boat, etc.)"
	AL["ENABLE_SCAN_RARES"] = "Toggle searching rare NPCs"
	AL["ENABLE_SCAN_RARES_DESC"] = "When this is activated you will be warned visually and with a sound everytime a rare NPC shows up in your minimap"
	AL["ENABLE_SCAN_WORLDMAP_VIGNETTES"] = "Toggle searching for entities through world map vignettes"
	AL["ENABLE_SCAN_WORLDMAP_VIGNETTES_DESC"] = "When this is activated you will be warned whenever an icon of a rare NPC, treasure or event appears on the world map. Be aware that this filter can be pretty annoying in places where the icons remain for a long time, so use it with caution."
	AL["ENABLE_SEARCHING_CONTAINER_TOOLTIP"] = "Enable alerts for this container"
	AL["ENABLE_SEARCHING_EVENT_TOOLTIP"] = "Enable alerts for this event"
	AL["ENABLE_SEARCHING_RARE_TOOLTIP"] = "Enable alerts for this rare NPC"
	AL["ENABLE_TOMTOM_SUPPORT"] = "Toggle Tomtom's support"
	AL["ENABLE_TOMTOM_SUPPORT_DESC"] = "When this is activated it will add a Tomtom's waypoint at the entitie's found coordinates"
	AL["ENABLE_WAYPOINTS_SUPPORT"] = "Toggle ingame waypoints support"
	AL["ENABLE_WAYPOINTS_SUPPORT_DESC"] = "When this is activated it will add an ingame waypoint at the entity's found coordinates. Important! The game adds a different icon on top of the entity, so you won't see the pink button, instead you have to look for a square icon."
	AL["ENABLED_SEARCHING_CONTAINER"] = "Enabled alerts for this container: %s"
	AL["ENABLED_SEARCHING_EVENT"] = "Enabled alerts for this event: %s"
	AL["ENABLED_SEARCHING_RARE"] = "Enabled alerts for this rare NPC: "
	AL["EVENT"] = "Event"
	AL["EVENT_FILTER"] = "Event filters"
	AL["EXPEDITION_ISLANDS"] = "Expedition islands"
	AL["EXPLORER_AUTO_FILTER"] = "Auto filter NPCs"
	AL["EXPLORER_AUTO_FILTER_DESC"] = "When this is activated, as soon as you collect all the missing items from a NPC, it will be automatically filtered."
	AL["EXPLORER_AUTOFILTER"] = "Auto-filtered [%s]. No more missing collectibles."
	AL["EXPLORER_BUTTON_TOOLTIP1"] = "Left-click to see details"
	AL["EXPLORER_BUTTON_TOOLTIP2"] = "Right-click to stop filtering this NPC"
	AL["EXPLORER_BUTTON_TOOLTIP3"] = "Right-click to filter this NPC"
	AL["EXPLORER_CREATE_BACKUP"] = "Create profile's backup"
	AL["EXPLORER_CREATE_BACKUP_DESC"] = "When this is activated, a backup of your current profile will be created when clicking on '%s'. This backup will allow you to return to your previous configurations if needed."
	AL["EXPLORER_FILTER_ACHIEVEMENT"] = "Is part of an achievement"
	AL["EXPLORER_FILTER_APPEARANCES"] = "Drops missing appearances"
	AL["EXPLORER_FILTER_COLLECTIONS"] = "Collections"
	AL["EXPLORER_FILTER_DEAD"] = "Show already killed NPCs"
	AL["EXPLORER_FILTER_FILTERED"] = "Show filtered NPCs"
	AL["EXPLORER_FILTER_MOUNTS"] = "Drops missing mounts"
	AL["EXPLORER_FILTER_PETS"] = "Drops missing pets"
	AL["EXPLORER_FILTER_STATE"] = "State"
	AL["EXPLORER_FILTER_TOYS"] = "Drops missing toys"
	AL["EXPLORER_FILTER_WITHOUT_COLLECTIBLES"] = "Show NPCs without missing collectibles"
	AL["EXPLORER_FILTERING"] = "Filter NPCs"
	AL["EXPLORER_FILTERING_CONTAINERS"] = "Analyzing containers to be filtered..."
	AL["EXPLORER_FILTERING_DESC"] = "Filter all the NPCs that don't drop any of the collectibles selected under \"%s - %s\" and unfilter the rest."
	AL["EXPLORER_FILTERING_DIALOG"] = "You are going to filter every single NPC that doesn't drop any of the collectibles selected under \"%s - %s\" (for example, if you only selected '%s' and '%s', you will filter all the NPCs that don't drop any of those collectibles and unfilter the ones that do). Do you want to continue?"
	AL["EXPLORER_FILTERING_NPCS"] = "Analyzing NPCs to be filtered..."
	AL["EXPLORER_FILTERS"] = "Filters"
	AL["EXPLORER_FOUND_CONTAINERS"] = "Found %s containers with missing collectibles..."
	AL["EXPLORER_FOUND_NPCS"] = "Found %s NPCs with missing collectibles..."
	AL["EXPLORER_MISSING_APPEARANCES"] = "Detected %s missing %s appearances..."
	AL["EXPLORER_MISSING_MOUNTS"] = "Detected %s missing mounts..."
	AL["EXPLORER_MISSING_PETS"] = "Detected %s missing pets..."
	AL["EXPLORER_MISSING_TOYS"] = "Detected %s missing toys..."
	AL["EXPLORER_NO_MISSING_APPEARANCES"] = "No missing appearances"
	AL["EXPLORER_NO_MISSING_MOUNTS"] = "No missing mounts"
	AL["EXPLORER_NO_MISSING_PETS"] = "No missing pets"
	AL["EXPLORER_NO_MISSING_TOYS"] = "No missing toys"
	AL["EXPLORER_NO_RESULTS"] = "No results found"
	AL["EXPLORER_RESCANN"] = "Rescan"
	AL["EXPLORER_RESCANN_DESC"] = "Forces a manual rescan for missing collectibles"
	AL["EXPLORER_SCAN_CLASS_REQUIRED"] = "New version of the database detected, a scan for the current class is required."
	AL["EXPLORER_SCAN_MANUAL"] = "Launching a manual rescan for the current class."
	AL["EXPLORER_SCAN_NOT_DONE"] = "You cannot use this filter because you haven't done a scan with RareScanner's explorer yet. Do you want to do it now?"
	AL["EXPLORER_SCAN_REQUIRED"] = "New version of the database detected, a new scan is required."
	AL["EXPLORER_START_SCAN"] = "Start scan"
	AL["FILTER"] = "NPC filters"
	AL["FILTER_CONTAINER_LIST"] = "Filter searching for containers"
	AL["FILTER_CONTAINER_LIST_DESC"] = "Toggle searching for this container. When disabled you won't get an alert when this container is found."
	AL["FILTER_CONTAINERS_ONLY_ALERTS_DESC"] = "When enabled you will still see filtered containers in your world map but you won't get visual/audio alerts. When disabled you won't see filtered containers in your world map and you won't get visual/audio alerts either."
	AL["FILTER_CONTAINERS_ONLY_MAP_DESC"] = "When enabled you will still get alerts from filtered containers but they won't show up in your world map. When disabled you won't see filtered containers in your world map and you won't get visual/audio alerts either."
	AL["FILTER_CONTINENT"] = "Continent/Category"
	AL["FILTER_CONTINENT_DESC"] = "Continent or category name"
	AL["FILTER_EVENT_LIST"] = "Filter searching for events"
	AL["FILTER_EVENT_LIST_DESC"] = "Toggle searching for this event. When disabled you won't get an alert when this event is found."
	AL["FILTER_EVENTS_ONLY_MAP_DESC"] = "When enabled you will still get alerts from filtered events but they won't show up in your world map. When disabled you won't get alerts from filtered events at all."
	AL["FILTER_NPCS_ONLY_MAP"] = "Apply filters only to the world map"
	AL["FILTER_NPCS_ONLY_MAP_DESC"] = "When enabled you will still get alerts from filtered NPCs but they won't show up in your world map. When disabled you won't get alerts from filtered NPCs at all."
	AL["FILTER_ONLY_ALERTS"] = "Apply filters only to the visual/audio alerts"
	AL["FILTER_RARE_LIST"] = "Filter searching for rare NPCs"
	AL["FILTER_RARE_LIST_DESC"] = "Toggle searching for this rare NPC. When disabled you won't get an alert when this NPC is found."
	AL["FILTER_ZONE"] = "Zone"
	AL["FILTER_ZONE_DESC"] = "Zone inside the continent or category"
	AL["FILTER_ZONES_LIST"] = "Zone list"
	AL["FILTER_ZONES_LIST_DESC"] = "Toggle alerts in this zone. When disabled you won't get an alert when a rare NPC, event or treasure is found in this zone."
	AL["FILTER_ZONES_ONLY_MAP"] = "Enable filters only in the world map"
	AL["FILTER_ZONES_ONLY_MAP_DESC"] = "When enabled you will still get alerts from NPCs that belong to filtered zones but they won't show up in your world map. When disabled you won't get alerts from NPCs that belong to filtered zones at all."
	AL["FILTERS"] = "Rare NPCs filters"
	AL["FILTERS_CONTAINERS_SEARCH_DESC"] = "Type the name of the container to filter the list below"
	AL["FILTERS_EVENTS_SEARCH_DESC"] = "Type the name of the event to filter the list below"
	AL["FILTERS_SEARCH"] = "Search"
	AL["FILTERS_SEARCH_DESC"] = "Type the name of the NPC to filter the list below"
	AL["GENERAL_OPTIONS"] = "General options"
	AL["GUIDE_ABUSE_OF_POWER"] = "An Abuse of Power"
	AL["GUIDE_ANIMA_CONDUCTOR"] = "Anima Conductor"
	AL["GUIDE_BOUNDING_SHROOM"] = "Bounding Shroom"
	AL["GUIDE_ENTRANCE"] = "Entrance"
	AL["GUIDE_LUNARLIGHT_BUD"] = "Lunarlight Bud"
	AL["GUIDE_PATH_START"] = "Path starts here"
	AL["GUIDE_SINSTONE_QUEST"] = "Sinstone repeatable quest"
	AL["GUIDE_SPECTRAL_KEY"] = "Spectral key"
	AL["GUIDE_TRANSPORT"] = "Transport"
	AL["INGAME_WAYPOINTS"] = "Ingame waypoints"
	AL["JUST_SPAWNED"] = "%s just showed up. Check your map!"
	AL["LEFT_BUTTON"] = "Left-click"
	AL["LOCK_BUTTON_POSITION"] = "Lock buttons position"
	AL["LOCK_BUTTON_POSITION_DESC"] = "When enabled you won't be able to change the position of the button by dragging and dropping it."
	AL["LOG_DONE"] = "Done"
	AL["LOG_FETCHING_COLLECTIONS"] = "Fetching missing collections..."
	AL["LOG_FILTERING_ENTITIES"] = "Filtering entities by loot..."
	AL["LOG_LOOT_FILTERS_APPLIED"] = "Loot filters modified to display only missing collections"
	AL["LOOT_CATEGORY_FILTERED"] = "Filter enabled for the category/subcategory: %s/%s. You can disable this filter by clicking again on the loot icon or from the RareScanner addon's menu"
	AL["LOOT_CATEGORY_FILTERS"] = "Category filters"
	AL["LOOT_CATEGORY_FILTERS_DESC"] = "Filter the loot shown by category"
	AL["LOOT_CATEGORY_NOT_FILTERED"] = "Filter disabled for the category/subcategory: %s/%s"
	AL["LOOT_COVENANT_REQUIREMENT"] = "Lootable only by %s."
	AL["LOOT_DISPLAY_OPTIONS"] = "Display options"
	AL["LOOT_DISPLAY_OPTIONS_DESC"] = "Display options for the loot bar"
	AL["LOOT_EXPLORER"] = "Explorer loot"
	AL["LOOT_EXPLORER_FILTER"] = "Filter items by explorer results"
	AL["LOOT_EXPLORER_FILTER_DESC"] = "In order to use this filter you have to perform a scan with RareScanner's explorer. When activated, you will be able to filter the loot displayed in the loot bar and world map tooltips by the missing colletibles detected."
	AL["LOOT_EXPLORER_FILTER_LONG_DESC"] = "In order to use these filters you have to scan with RareScanner's explorer. This process will detect every missing mount, pet, toy and appearance for your current character. |cffffff00Important!: These filters will override the filters under 'Category filters'.|r"
	AL["LOOT_EXPLORER_OPEN"] = "Open explorer"
	AL["LOOT_EXPLORER_SHOW_MISSING_APPEARANCES"] = "Show missing appearances"
	AL["LOOT_EXPLORER_SHOW_MISSING_APPEARANCES_DESC"] = "When activated, you will see missing appearances found explorer the scan in the loot bar and world map tooltips."
	AL["LOOT_EXPLORER_SHOW_MISSING_MOUNTS"] = "Show missing mounts"
	AL["LOOT_EXPLORER_SHOW_MISSING_MOUNTS_DESC"] = "When activated, you will see missing mounts found via the explorer in the loot bar and world map tooltips."
	AL["LOOT_EXPLORER_SHOW_MISSING_PETS"] = "Show missing pets"
	AL["LOOT_EXPLORER_SHOW_MISSING_PETS_DESC"] = "When activated, you will see missing pets found via the explorer in the loot bar and world map tooltips."
	AL["LOOT_EXPLORER_SHOW_MISSING_TOYS"] = "Show missing toys"
	AL["LOOT_EXPLORER_SHOW_MISSING_TOYS_DESC"] = "When activated, you will see missing toys found via the explorer in the loot bar and world map tooltips."
	AL["LOOT_FILTER_ANIMA_ITEMS"] = "Filter items that increase your Anima"
	AL["LOOT_FILTER_ANIMA_ITEMS_DESC"] = "When activated, any item that increase your Anima, won't show up on the loot bar."
	AL["LOOT_FILTER_COMPLETED_QUEST"] = "Filter quest items that don't begin a new quest"
	AL["LOOT_FILTER_COMPLETED_QUEST_DESC"] = "When activated, any item that is a requirement for a quest, or that begins an already completed quest, won't show up on the loot bar."
	AL["LOOT_FILTER_CONDUIT_ITEMS"] = "Filter conduits that you cannot use"
	AL["LOOT_FILTER_CONDUIT_ITEMS_DESC"] = "When activated, any conduit that you cannot use or that you have already collected, won't show up on the loot bar."
	AL["LOOT_FILTER_ITEM_LIST"] = "Filtered items"
	AL["LOOT_FILTER_NOT_MATCHING_CLASS"] = "Filter items that require a different class than yours"
	AL["LOOT_FILTER_NOT_MATCHING_CLASS_DESC"] = "When activated, any item that requires a specific class to be used that doesn't match yours, won't show up on the loot bar."
	AL["LOOT_FILTER_NOT_MATCHING_FACTION"] = "Filter items that require a different faction than yours"
	AL["LOOT_FILTER_NOT_MATCHING_FACTION_DESC"] = "When activated, any item that requires a specific faction to be used that doesn't match yours, won't show up on the loot bar."
	AL["LOOT_FILTER_SUBCATEGORY_DESC"] = "Toggle showing this kind of loot on the loot bar. When disabled you won't see any item that matches this category on the loot shown when you find a rare NPC."
	AL["LOOT_FILTER_SUBCATEGORY_LIST"] = "Subcategories"
	AL["LOOT_FILTERS"] = "Loot filters"
	AL["LOOT_FILTERS_DESC"] = "Filter the loot shown in the world map and the loot bar"
	AL["LOOT_INDIVIDUAL_FILTERED"] = "Filter enabled for %s. You can disable this filter by clicking again on the loot icon or from the RareScanner addon's menu"
	AL["LOOT_INDIVIDUAL_FILTERS"] = "Individual item filters"
	AL["LOOT_INDIVIDUAL_FILTERS_DESC"] = "In order to add items to this list you have to filter them by directly clicking on the icons that show up in the tooltips in the worldmap or in the loot bar."
	AL["LOOT_INDIVIDUAL_NOT_FILTERED"] = "Filter disabled for %s."
	AL["LOOT_ITEMS_PER_ROW"] = "Number of items per row to display"
	AL["LOOT_ITEMS_PER_ROW_DESC"] = "Sets the number of items to display per row on the loot bar. If the number is less than the maximum several rows will be displayed."
	AL["LOOT_MAIN_CATEGORY"] = "Main category"
	AL["LOOT_MAX_ITEMS"] = "Number of items to display"
	AL["LOOT_MAX_ITEMS_DESC"] = "Sets the maximum number of items to display on the loot bar."
	AL["LOOT_MIN_QUALITY"] = "Minimum loot quality"
	AL["LOOT_MIN_QUALITY_DESC"] = "Defines the minimum loot quality to show in the loot bar"
	AL["LOOT_OPTIONS"] = "Loot options"
	AL["LOOT_OTHER_FILTERS"] = "Other filters"
	AL["LOOT_OTHER_FILTERS_DESC"] = "Other filters"
	AL["LOOT_PANEL_OPTIONS"] = "Loot bar options"
	AL["LOOT_RESET"] = "Reset filters"
	AL["LOOT_RESET_DESC"] = "Click the button to reset all the filters to its default values. This doesn't modify your individual item filters."
	AL["LOOT_RESET_DONE"] = "Loot filters restored"
	AL["LOOT_SEARCH_ITEMS_DESC"] = "Type the name of the item to filter the list below"
	AL["LOOT_SUBCATEGORY_FILTERS"] = "Subcategory filters"
	AL["LOOT_TOGGLE_FILTER"] = "Alt-Left-Click to filter the category (%s/%s)"
	AL["LOOT_TOGGLE_INDIVIDUAL_FILTER"] = "Alt-Shift-Left-Click to filter this item"
	AL["LOOT_TOOLTIP_POSITION"] = "Loot tooltip position"
	AL["LOOT_TOOLTIP_POSITION_DESC"] = "Defines where to show the loot tooltip that appears when you move the mouse over an icon, in respect to the button"
	AL["LOOT_TOOLTIPS_CANIMOGIT"] = "CanIMogIt support"
	AL["LOOT_TOOLTIPS_CANIMOGIT_DESC"] = "Toggle showing CanIMogIt information in the loot tooltips."
	AL["LOOT_TOOLTIPS_COVENANT"] = "Toggle covenant requirement"
	AL["LOOT_TOOLTIPS_COVENANT_DESC"] = "Some items are lootable only by a specific covenant. When enabled it will show in these items tooltip the covenant required."
	AL["MAIN_BUTTON_OPTIONS"] = "Main button options"
	AL["MAP_CONTAINERS_ICONS"] = "Containers"
	AL["MAP_EVENTS_ICONS"] = "Events"
	AL["MAP_ICONS"] = "Icons"
	AL["MAP_ICONS_DESC"] = "Options to configure what icons you want to display in the world map"
	AL["MAP_MENU_DISABLE_LAST_SEEN_CONTAINER_FILTER"] = "Show containers that you saw a long time ago but that can respawn"
	AL["MAP_MENU_DISABLE_LAST_SEEN_EVENT_FILTER"] = "Show events that you saw a long time ago but that can respawn"
	AL["MAP_MENU_DISABLE_LAST_SEEN_FILTER"] = "Show rare NPCs that you saw a long time ago but that can respawn"
	AL["MAP_MENU_SHOW_CONTAINERS"] = "Show container icons on map"
	AL["MAP_MENU_SHOW_DRAGON_GLYPHS"] = "Show dragon glyphs icons on map"
	AL["MAP_MENU_SHOW_EVENTS"] = "Show event icons on map"
	AL["MAP_MENU_SHOW_NOT_DISCOVERED"] = "Not discovered entities"
	AL["MAP_MENU_SHOW_NOT_DISCOVERED_OLD"] = "Not discovered entities (older expansions)"
	AL["MAP_MENU_SHOW_RARE_NPCS"] = "Show rare NPC icons on map"
	AL["MAP_NEVER"] = "Never"
	AL["MAP_NOT_DISCOVERED_ICONS"] = "Not discovered entities"
	AL["MAP_NPCS_ICONS"] = "NPCs"
	AL["MAP_OPTIONS"] = "Map options"
	AL["MAP_OTHER_ICONS"] = "Other icons"
	AL["MAP_SCALE_ICONS"] = "Scale of the icons in the world map"
	AL["MAP_SCALE_ICONS_DESC"] = "This will adjust the scale of the icons in the world map, being the value of 1 the original size."
	AL["MAP_SEARCHER"] = "World map searcher"
	AL["MAP_SEARCHER_CLEAR"] = "Toggle cleaning the search box on map close"
	AL["MAP_SEARCHER_CLEAR_DESC"] = "When enabled, the value typed in the search box will be cleared every time you close the world map."
	AL["MAP_SEARCHER_DESC"] = "Options to configure the search box displayed in the world map to search for entities"
	AL["MAP_SEARCHER_DISPLAY"] = "Toggle showing the search box"
	AL["MAP_SEARCHER_DISPLAY_DESC"] = "When disabled the search box won't be shown in your world map"
	AL["MAP_SEARCHER_TOOLTIP_DESC"] = "Type the name of the entity you are looking for and press ENTER."
	AL["MAP_SEARCHER_TOOLTIP_TITLE"] = "RareScanner searcher"
	AL["MAP_SHOW_ICON_AFTER_COLLECTED"] = "Keep showing container icons after looted"
	AL["MAP_SHOW_ICON_AFTER_COLLECTED_DESC"] = "When disabled the icon will disappear after you loot the container."
	AL["MAP_SHOW_ICON_AFTER_COMPLETED"] = "Keep showing event icons after completion"
	AL["MAP_SHOW_ICON_AFTER_COMPLETED_DESC"] = "When disabled the icon will disappear after you complete the event."
	AL["MAP_SHOW_ICON_AFTER_DEAD"] = "Keep showing NPC icons after death"
	AL["MAP_SHOW_ICON_AFTER_DEAD_DESC"] = "When disabled the icon will disappear after you kill the NPC. The icon will reappear as soon as you find the NPC again. This option only works with NPCs that keep being rares after killing them."
	AL["MAP_SHOW_ICON_AFTER_DEAD_RESETEABLE"] = "Keep showing NPC icons after death (only in resettable zones)"
	AL["MAP_SHOW_ICON_AFTER_DEAD_RESETEABLE_DESC"] = "When disabled the icon will disappear after you kill the NPC. The icon will reappear as soon as you find the NPC again. This option only works with NPCs that keep being rares after killing them in zones that reset with world quests."
	AL["MAP_SHOW_ICON_CONTAINER_MAX_SEEN_TIME"] = "Timer to hide container icons (in minutes)"
	AL["MAP_SHOW_ICON_CONTAINER_MAX_SEEN_TIME_DESC"] = "Sets the maximum number of minutes since you have seen the container. After that time, the icon won't be shown on the world map until you find the container again. If you select zero minutes the icons will be shown regardless of how long since you have seen the container. This filter doesn't apply to containers that are part of an achievement."
	AL["MAP_SHOW_ICON_EVENT_MAX_SEEN_TIME"] = "Timer to hide event icons (in minutes)"
	AL["MAP_SHOW_ICON_EVENT_MAX_SEEN_TIME_DESC"] = "Sets the maximum number of minutes since you have seen the event. After that time, the icon won't be shown on the world map until you find the event again. If you select zero minutes the icons will be shown regardless of how long since you have seen the event."
	AL["MAP_SHOW_ICON_MAX_SEEN_TIME"] = "Timer to hide rare NPC icons (in minutes)"
	AL["MAP_SHOW_ICON_MAX_SEEN_TIME_DESC"] = "Sets the maximum number of minutes since you have seen the NPC. After that time, the icon won't be shown on the world map until you find the NPC again. If you select zero minutes the icons will be shown regardless of how long since you have seen the rare NPC."
	AL["MAP_SPAWN_SPOTS"] = "Spawn spots"
	AL["MAP_SPAWN_SPOTS_COLOUR"] = "Colour spots entity nº %s"
	AL["MAP_SPAWN_SPOTS_DESC"] = "Options to configure the spawning spots shown in the worldmap"
	AL["MAP_TIMERS"] = "Timers"
	AL["MAP_TIMERS_DESC"] = "Options to configure the amount of time that you want to display the icons in the world map"
	AL["MAP_TOOLTIP_ADD_WAYPOINT"] = "Add a waypoint to this position"
	AL["MAP_TOOLTIP_DAYS"] = "days"
	AL["MAP_TOOLTIP_FILTER_ENTITY"] = "Filter this entity"
	AL["MAP_TOOLTIP_NOT_FOUND"] = "You haven't seen this entity"
	AL["MAP_TOOLTIP_RESPAWN"] = "Respawn in: %s"
	AL["MAP_TOOLTIP_SEEN"] = "Seen before: %s"
	AL["MAP_TOOLTIP_SHOW_GUIDE"] = "Show guide icons"
	AL["MAP_TOOLTIP_SHOW_OVERLAY"] = "Show every spawning spot"
	AL["MAP_TOOLTIPS"] = "Tooltips"
	AL["MAP_TOOLTIPS_ACHIEVEMENT"] = "Show achievement information"
	AL["MAP_TOOLTIPS_ACHIEVEMENT_DESC"] = "When disabled you won't see information about achievements in the tooltips."
	AL["MAP_TOOLTIPS_COMMANDS"] = "Show commands"
	AL["MAP_TOOLTIPS_COMMANDS_DESC"] = "When disabled you won't see the description of the commands on the bottom part of the tooltip."
	AL["MAP_TOOLTIPS_DESC"] = "Options to configure what to show in the tooltips"
	AL["MAP_TOOLTIPS_LOOT"] = "Show loot"
	AL["MAP_TOOLTIPS_LOOT_ACHIEVEMENT"] = "Loot/Achievements"
	AL["MAP_TOOLTIPS_LOOT_ACHIEVEMENT_POSITION"] = "Loot/Achievement tooltip position"
	AL["MAP_TOOLTIPS_LOOT_ACHIEVEMENT_POSITION_DESC"] = "Defines where to show the loot and achievement tooltips in respect to the parent tooltip."
	AL["MAP_TOOLTIPS_LOOT_ACHIEVEMENT_SCALE"] = "Scale of the loot/achievements tooltips"
	AL["MAP_TOOLTIPS_LOOT_ACHIEVEMENT_SCALE_DESC"] = "This will adjust the scale of the loot and achievements tooltips in the worldmap."
	AL["MAP_TOOLTIPS_LOOT_DESC"] = "When disabled you won't see the loot in the tooltips."
	AL["MAP_TOOLTIPS_NOTES"] = "Show notes"
	AL["MAP_TOOLTIPS_NOTES_DESC"] = "When disabled you won't see notes in the tooltips."
	AL["MAP_TOOLTIPS_SCALE"] = "Scale of the tooltips in the worldmap"
	AL["MAP_TOOLTIPS_SCALE_DESC"] = "This will adjust the scale of the tooltips in the worldmap."
	AL["MAP_TOOLTIPS_SEEN"] = "Show last time seen"
	AL["MAP_TOOLTIPS_SEEN_DESC"] = "When disabled you won't see how much time has passed since you saw the entity."
	AL["MAP_TOOLTIPS_STATE"] = "Show the entity's state"
	AL["MAP_TOOLTIPS_STATE_DESC"] = "When disabled you won't see information related to the state of the entity (dead, opened or completed and respawn time). This tooltip only appears with blue icons."
	AL["MAP_TOOLTIPS_WORLDMAP_ICONS"] = "Show tooltips with ingame world map icons"
	AL["MAP_TOOLTIPS_WORLDMAP_ICONS_DESC"] = "When disabled you won't see tooltips on ingame world map icons"
	AL["MAP_WAYPOINT_INGAME"] = "Toggle ingame waypoints"
	AL["MAP_WAYPOINT_INGAME_DESC"] = "When enabled you will be able to add an ingame waypoint with 'shift-left-click' on the world map icons."
	AL["MAP_WAYPOINT_TOMTOM"] = "Toggle Tomtom waypoints"
	AL["MAP_WAYPOINT_TOMTOM_DESC"] = "When enabled you will be able to add a Tomtom waypoint with 'shift-left-click' on the world map icons."
	AL["MAP_WAYPOINTS"] = "Waypoints"
	AL["MAP_WAYPOINTS_DESC"] = "Options to configure waypoints added by clicking on the world map icons."
	AL["MARKER"] = "Target marker"
	AL["MARKER_DESC"] = "Choose the marker to add on top of the target when you click the main button."
	AL["MESSAGE_OPTIONS"] = "Messages options"
	AL["MIDDLE_BUTTON"] = "Middle-click"
	AL["MINIMAP_ICON_TOOLTIP1"] = "Left-click to open RareScanner explorer"
	AL["MINIMAP_ICON_TOOLTIP2"] = "Right-click to open RareScanner options panel"
	AL["MINIMAP_SCALE_ICONS"] = "Scale of the icons in the minimap"
	AL["MINIMAP_SCALE_ICONS_DESC"] = "This will adjust the scale of the icons in the minimap, being the value of 0.7 the original size."
	AL["NAVIGATION_ENABLE"] = "Toggle navigation"
	AL["NAVIGATION_ENABLE_DESC"] = "When enabled the navigation arrows will show up beside the main button to allow you access to newer or older entities found"
	AL["NAVIGATION_LOCK_ENTITY"] = "Block display of new entities if one is already shown"
	AL["NAVIGATION_LOCK_ENTITY_DESC"] = "When enabled, if the main button is displaying an entity in your screen, it won't update to a newer one automatically. An arrow will appear allowing you to access the new entity whenever you are ready"
	AL["NAVIGATION_OPTIONS"] = "Navigation options"
	AL["NAVIGATION_SHOW_NEXT"] = "Show next entity found"
	AL["NAVIGATION_SHOW_PREVIOUS"] = "Show previous entity found"
	AL["NOT_TARGETEABLE"] = "Not targetable"
	AL["NOTE_10263"] = "The [Scarshield Warlock] opens a portal every now and then where the rare NPC can be summoned from."
	AL["NOTE_129836"] = "It doesn't have a vignette, so you won't get the alert from it. It is in the basement of the building."
	AL["NOTE_130350"] = "You have to ride this rare to the container that you will find by following the path to the right of this position."
	AL["NOTE_131453"] = "You have to ride [Guardian of the Spring] to this position. The horse is a friendly rare that you will find by following the path to the left of this container."
	AL["NOTE_131735"] = "He is a neutral NPC. Once you kill him, a little piggy will show up giving you the pet [Taptaf]"
	AL["NOTE_135448"] = "Only available in mythic difficulty. You have to find a [Discarded Cell Key] (they spawn on top of the furniture around the place) to open the prison where this skull shows up. Once inside, go through the hole on the wall and arrive to a room with a bucket. Click on it to summon the rare NPC."
	AL["NOTE_135497"] = "Only available while doing the daily quest [Aid from Nordrassil] obtained from Mylune. While you are on this quest you will find mushrooms under the trees. Clicking on them might spawn this NPC."
	AL["NOTE_140474"] = "You have to collect 20x[Abyssal Fragment] (world drop). Once you have the 20 items go to the coordinates 73.23 (behind a waterfall), and click on them to create [Abhorrent Essence of the Abyss]. Next go to a mine at the coordinates 43.36. Once you are inside the mine, go to the coordinates 59.54 where you will find a statue where you can use the new item to summon this rare NPC."
	AL["NOTE_149847"] = "When you approach to him, he will tell you a colour that he hates. Once you know what colour it is, you have to go to the coordinates 63.41 where you will be painted that colour. When you will come back to his position, he will attack you."
	AL["NOTE_149886"] = "He will show up ONLY once as soon as you step into the Royal Library. It's just a mere tribute to Stan Lee from Marvel."
	AL["NOTE_149887"] = "He will show up ONLY once as soon as you step into the house at this position. It's just a mere tribute to Stan Lee from Marvel."
	AL["NOTE_150342"] = "Only available during the event [Drill Rig DR-TR35]."
	AL["NOTE_150394"] = "In order to kill him you have to bring him to the coordinates 63.38, where there is a device with blue lightning. Once the NPC is touched by lightning, it will explode and you will be able to loot him."
	AL["NOTE_151124"] = "You have to loot a [Smashed Transport Relay] from the enemies that appear during the event [Drill Rig DR-JD99] (coordinates 59.67) and then use it on the machine that is found on the platform."
	AL["NOTE_151159"] = "He is available only when [Oglethorpe Obnoticus] is in Mechagon (coordinates 72.37). He wanders around Mechagon, so check in every street. Killing him makes [OOX-Avenger/MG] to spawn."
	AL["NOTE_151202"] = "In order to summon him you have to connect the [Wires] on the shore, with the [Pylons] inside the water."
	AL["NOTE_151296"] = "First check if [Oglethorpe Obnoticus] is in Mechagon (coordinates 72.37). If he is there, then you have to find and kill [OOX-Fleetfoot/MG] (it is a chicken robot wandering around Mechagon). Once you find him and kill him, come back to this icon's coordinates."
	AL["NOTE_151308"] = "Only available during [Drill Rig] events."
	AL["NOTE_151569"] = "You require a [Hundred-Fathom Lure] to summon it."
	AL["NOTE_151627"] = "You need to use a [Exothermic Evaporator Coil] on the machine that is found on the platform."
	AL["NOTE_151933"] = "In order to kill him you have to use [Beastbot Powerpack] (you can get the schema at the coordinates 60.41)."
	AL["NOTE_152007"] = "It is wandering in this area, so the coordinates might not be very accurate."
	AL["NOTE_152113"] = "Only available during the event [Drill Rig DR-CC88]."
	AL["NOTE_152569"] = "When you approach to him, he will tell you a colour that he hates. Once you know what colour it is, you have to go to the coordinates 63.41 where you will be painted that colour. When you will come back to his position, he will attack you."
	AL["NOTE_152570"] = "When you approach to him, he will tell you a colour that he hates. Once you know what colour it is, you have to go to the coordinates 63.41 where you will be painted that colour. When you will come back to his position, he will attack you."
	AL["NOTE_153000"] = "Only available while the daily quest [Bugs, Lots of 'Em!] is active."
	AL["NOTE_153200"] = "Only available during the event [Drill Rig DR-JD41]."
	AL["NOTE_153205"] = "Only available during the event [Drill Rig DR-JD99]."
	AL["NOTE_153206"] = "Only available during the event [Drill Rig DR-TR28]."
	AL["NOTE_153228"] = "It shows up after killing a LOT of [Upgraded Sentry] that wander around the area."
	AL["NOTE_154148"] = "You have to click on 4 [Undisturbed Specimen] (some sort of void eggs that are attached to the columns in the area) to summon her."
	AL["NOTE_154225"] = "He is available only on the interface that you can access using [Personal Time Displacer] that you can create with resources collected in Mechagon. Important: He won't spawn while Chromie's daily quest is available."
	AL["NOTE_154332"] = "It is in a cave. The entrance is located at the coordinates 57,38."
	AL["NOTE_154333"] = "It is in a cave. The entrance is located at the coordinates 57,38."
	AL["NOTE_154342"] = "He is available only on the interface that you can access using [Personal Time Displacer] that you can create with resources collected in Mechagon."
	AL["NOTE_154559"] = "It is in a cave. The entrance is located at the coordinates 70,58."
	AL["NOTE_154604"] = "It is in a cave. The entrance is located at the coordinates 36,20."
	AL["NOTE_154701"] = "Only available during the event [Drill Rig DR-CC61]."
	AL["NOTE_154739"] = "Only available during the event [Drill Rig DR-CC73]."
	AL["NOTE_155531"] = "You have to use the orb above him (Essence of the Sun) to get [Aura of the Sun] and be able to attack him."
	AL["NOTE_156709"] = "You have to kill Faceless Despoiler (normal NPC) to force this one to spawn."
	AL["NOTE_157125"] = "You have to complete the quest [Ani-Matter Animator] (given by [Synder Sixfold]). Once you have completed the quest, you can talk to [Synder Sixfold] to obtain [Ani-Matter Orb]. Use his item beside [Bone Mass] to summon him."
	AL["NOTE_157125_1"] = "Synder Sixfold"
	AL["NOTE_157162"] = "Inside the temple. The entrance is located at the coordinates 22,24."
	AL["NOTE_157294"] = "Add more [Viscous oil] than other materials."
	AL["NOTE_157307"] = "Add more [Miscible Ooze] than other materials."
	AL["NOTE_157308"] = "Add more [Mephitic goo] than other materials."
	AL["NOTE_157309"] = "Add more [Mephitic goo] and [Viscous oil] than [Miscible Ooze]."
	AL["NOTE_157310"] = "Add more [Mephitic goo] and [Miscible Ooze] than [Viscous oil]."
	AL["NOTE_157311"] = "Add more [Viscous oil] and [Miscible Ooze] than [Mephitic goo]."
	AL["NOTE_157312"] = "Add 10 of each material."
	AL["NOTE_158531"] = "You have to kill Voidwarped Neferset (normal NPC) to force this one to spawn."
	AL["NOTE_158632"] = "You have to kill Burbling Fleshbeast (normal NPC) to force this one to spawn."
	AL["NOTE_158659"] = "You need 10 [Weak Anima Mote] to activate him. You can find them in [Depleted Anima Canisters] (around the area)."
	AL["NOTE_158706"] = "You have to kill Oozing Putrefaction (normal NPC) to force this one to spawn."
	AL["NOTE_159087"] = "You have to kill N'Zoth Bonestripper (normal NPC) to force this one to spawn."
	AL["NOTE_159496"] = "Then you will be able to interact with [Madalav's Hammer] to summon him."
	AL["NOTE_159753"] = "You have to start killing [Boneweave Spiderling] in the area to spawn him."
	AL["NOTE_159886"] = "In order to be able to attack him you have to first kill [Intricate Webbing]."
	AL["NOTE_160059"] = "It shares the spawn spot with [Taskmaster Mortis] and [Taskmaster Bloata] (normal elites), so if you find one of these, kill them until the rare NPC spawns."
	AL["NOTE_160385"] = "This is the first place where you will fight this NPC. At 70% of life she will vanish. You have to follow her through the portal that is located downstairs, on the left side of the tower."
	AL["NOTE_160392"] = "This is the third and last place where you will fight this NPC. The combat starts at the coordinates 79,50."
	AL["NOTE_160393"] = "This is the second place where you will fight this NPC. The combat starts at the coordinates 79,50. At 30% of life she will vanish. You have to follow her through the portal."
	AL["NOTE_160629"] = "In order to be able to attack him you have to take [Plates of Purian] around the area and feed him putting them in his barrel (Baedos' Fruit Barrel). After several plates you will be able to attack him."
	AL["NOTE_160640"] = "He is inside the crypt. You have to kill [Feral Ritualist] in the area to loot [Scorched Crypt Key] to open the door. Another way is to die and pass through like a ghost."
	AL["NOTE_160675"] = "To summon this NPC you need to collect 4x[Forbidden Tomes] from the area and put them in the [Forbidden Libary] (inside the building)."
	AL["NOTE_160821"] = "In order to summon him you have to use an [Enticing Anima] to light worldedge braziers. This item is dropped by [Encroaching Mite]s along the river."
	AL["NOTE_160857"] = "You have to find [Remnant of Light] around the area (they are yellow glasses on the ground). This item will give you [Light Impalement]. Use this spell on [Crazed Ash Ghoul] to spawn this rare NPC."
	AL["NOTE_160968"] = "Inside the temple. The entrance is located at the coordinates 22,24."
	AL["NOTE_161105"] = "Use [Fuseless Special] to remove its shield. The bombs are located around the area."
	AL["NOTE_161857"] = "He is available only during the world quest [Deadly Reminder]."
	AL["NOTE_161891"] = "In order to summon him you need to collect 4x[Mortegore Scroll] and use them on [Mortegore Sigil]. This item is dropped by random mobs within the area."
	AL["NOTE_162171"] = "It is in a cave. The entrance is located at the coordinates 45,58."
	AL["NOTE_162180"] = "This rare NPC shares the spawn spot with the [Razorthread Weaver] in the room. Kill them several times until it spawns."
	AL["NOTE_162352"] = "It is in a cave. The entrance is underwater at the coordinates 52,40."
	AL["NOTE_162481"] = "In order to summon him you have to interact with the [Catacombs Cache] that is inside a death golem. Once you kill him the [Catacombs Cache] will appear with loot."
	AL["NOTE_162588"] = "In order to be able to attack him you have to destroy all the [Unusual Egg]s."
	AL["NOTE_162588_1"] = "Unusual Eggs"
	AL["NOTE_162741"] = "Then you will be able to interact with the [Final Thread] to summon him."
	AL["NOTE_163460"] = "He is underground."
	AL["NOTE_164093"] = "You need 3 players to summon it. Get into the [Mushroom Ring] and '/dance' with each other. After some seconds the NPC will show up."
	AL["NOTE_164107"] = "In order to force him to spawn, start killing [Deranged Guardian] and the rider [Bristlecone Terror] until [Chompy] and the rare NPC spawns."
	AL["NOTE_164112"] = "In order to summon him find a [Unusually Large Mushroom] (drop from [Lurking Lasher]) and use it on the [Damp Loam]. After 1 minute the rare NPC will appear."
	AL["NOTE_164112_1"] = "You can find [Lurking Lasher]s here"
	AL["NOTE_164238"] = "If it passes next to you, click on him to ride him! Once you are on top, just kick him to slow him down and damage it."
	AL["NOTE_164388"] = "Disable the 3x[Mirror Trap]s to start the combat."
	AL["NOTE_164391"] = "It is flying really high. In order to reach to him, use the [Basket of Enchanted Wings] and fly to its position."
	AL["NOTE_164391_1"] = "Basket of Enchanted Wings"
	AL["NOTE_164415"] = "You have to be a member of the [Night Fae] Covenant. He is in a cave that has a magic door. You need to use [Soulshape] to go through it."
	AL["NOTE_164547"] = "Someone in your realm has to play the [Great Horn of the Runestag] to summon him."
	AL["NOTE_164547_1"] = "You might find [Great Horn of the Runestag] here."
	AL["NOTE_165152"] = "He is underground. As soon as you approach him an event will start and [Prideful Hulk] (another rare NPC) will show up."
	AL["NOTE_165175"] = "He is underground. If [Leeched Soul] is alive, move close to him and an event will start. Once it is completed [Prideful Hulk] will show up."
	AL["NOTE_165206"] = "Take the [Anima Stake] and use it in the big blue light area to make this NPC spawn."
	AL["NOTE_165206_1"] = "Anima Stake"
	AL["NOTE_165290"] = "Then you will be able to repair the [Ballista] to shoot him down. Bring 2x[Dredhollow Tools] to [Muckborn Craftsman] and 1x[Dredhollow Bolt] to [Wingsmash]. He will shoot him and the combat will start."
	AL["NOTE_165290_1"] = "Dredhollow Tools"
	AL["NOTE_165290_2"] = "Muckborn Craftsman"
	AL["NOTE_165290_3"] = "Dredhollow Bolt"
	AL["NOTE_165290_4"] = "Wingsmash"
	AL["NOTE_166292"] = "He is available only during the world quest [Muck It Up]. Collect [Primordial Muck] (quest item) and use it on the water to have a chance to summon the NPC."
	AL["NOTE_166393"] = "Use the [Rubbish Box] around the area and throw the rubbish to the water. Start killing [Violent Muckmare] until the NPC spawns."
	AL["NOTE_166521"] = "You need a group to kill him. Talk to [Seeker Hilda] to start the event that will make him show up."
	AL["NOTE_166679"] = "You have to interact with the [Large Prey] to spawn this NPC."
	AL["NOTE_166710"] = "In order to remove his shield you have to kill 3x[Stone Legion Punisher]. They are standing right beside the wall where this NPCs is flying along."
	AL["NOTE_167078"] = "Then you will be able to interact with the [Horn of Courage] to summon him."
	AL["NOTE_167078_1"] = "Horn of Courage"
	AL["NOTE_167464"] = "Kill all the NPCs around him to start the combat."
	AL["NOTE_167721"] = "It is hidden in the [Strange Cloud]. You won't see the NPC, but if you got the alert it is there. In order to kill him you have to go to the center of the cloud and use some AOE damage until you hit him. The issue here is that you will fall asleep as soon as you step in, so first hit a [Greater Ardenmoth] nearby until you get the poison [Anima Toxin] which will keep you awake inside the cloud for 15 seconds."
	AL["NOTE_167851"] = "It is in a cave."
	AL["NOTE_168135"] = "In order to see this NPC you have to use [Dream Catcher]. Right-click for more instructions."
	AL["NOTE_168135_1"] = "Tricky part! Jump to the root in front and follow up to reach 2."
	AL["NOTE_168135_2"] = "Once on top of the bigger root, jump to the land underneath and walk to reach 3."
	AL["NOTE_168135_3"] = "Obtain [Broken Soulweb] (on top of the mountain and underneath the cart)"
	AL["NOTE_168135_4"] = "Complete quest [Outplayed] (giver [Lady of the Falls]). Series of quests starting with [Ages-Echoing Wisdom]"
	AL["NOTE_168135_5"] = "Requires 10x[Lightless Silk]. Repair [Broken Soulweb] talking to [Elder Gwenna]"
	AL["NOTE_168135_6"] = "Obtain [Dream Catcher] by talking to [Ysera]. If you aren't part of the [Night Fae] Covenant speak with the guards outside the [Heart of Forest] and she will come out."
	AL["NOTE_168647"] = "Then you will be able to interact with the [Sparkling Animaseed] and get [Animaseed Light] to unlock the rare NPC."
	AL["NOTE_170048"] = "In order to summon him the world quest [Swarming Souls] has to be active. Important, don't complete it until he spawns!. While the quest is up, bring several [Lost Soul]s to [Avowed Ritualist]."
	AL["NOTE_170048_1"] = "Avowed Ritualist"
	AL["NOTE_170406"] = "There is a little cricket carrying the treasure, you have to step on him to be able to loot it"
	AL["NOTE_170434"] = "He is available only during the world quest [Summon Your Sins]. After collecting 20x[Sinstone Fragment] you need to chose the [Catalyst of Power]. Then you will receive [Amalgamation of Sin] to summon him."
	AL["NOTE_170439"] = "You have to use the [Ancient memorial] to get [Sunrider's Blessing] and then use [Skystrider Glider] to reach him. The object [Skystrider Glider] is obtained with the [Kyrian] covenant, upgrading the Trial of Ascension to level 4 to unlock trials of wisdom. Then defeat [Kalisthene] to get the [Blueprint: Skystrider Glider] and craft the item."
	AL["NOTE_170439_1"] = "Ancient memorial"
	AL["NOTE_170439_2"] = "Wait for the NPC and jump down here. Then use [Skystrider Glider]."
	AL["NOTE_170623"] = "In order to spawn this NPC you have to die. In spirit form you will find the NPC, and you have to talk to him to resurrect and start the combat. If instead of the rare NPC you find to [Vesiphone] then someone has killed him not a long time ago and you will have to wait."
	AL["NOTE_170659"] = "In order to make him spawn, get purple eyes on top of your head. If you move around they will get bigger and bigger. Wait for approximately a minute and it will show up."
	AL["NOTE_170659_1"] = "Walk around this area to get purple eyes on your head"
	AL["NOTE_170832_1"] = "Vesper of Courage"
	AL["NOTE_170832_2"] = "Vesper of Humility"
	AL["NOTE_170832_3"] = "Vesper of Purity"
	AL["NOTE_170832_4"] = "Vesper of Wisdom"
	AL["NOTE_170832_5"] = "Vesper of Loyalty"
	AL["NOTE_171008"] = "In order to summon him pull 1x[Unstable Memory Fragment] that are around the ring in front of this icon. Then move him close to other [Unstable Memory Fragment]s. He will absorb them and increase the stacks of [Instability]. As soon as it reaches 10 it will become this rare NPC."
	AL["NOTE_171011"] = "When you defeat him he drops a chest [Relic Hoard]."
	AL["NOTE_171014"] = "You have to collect 6x[Mercia's Legacy Chapter] in order from 1 to 6. Then talk to [Echo of Mercia] to get the buff [Humble Gaze]. While this buff is activate you can find the 7th Chapter (if you lose the buff talk again to [Echo of Mercia]). Once you have it talk back to [Echo of Mercia] and the NPC will show up. Tip: Zoom in your minimap to see the guide icons."
	AL["NOTE_171014_1"] = "Mercia's Legacy: Chapter One"
	AL["NOTE_171014_2"] = "Mercia's Legacy: Chapter Two"
	AL["NOTE_171014_3"] = "Mercia's Legacy: Chapter Three"
	AL["NOTE_171014_4"] = "Mercia's Legacy: Chapter Four"
	AL["NOTE_171014_5"] = "Mercia's Legacy: Chapter Five"
	AL["NOTE_171014_6"] = "Mercia's Legacy: Chapter Six"
	AL["NOTE_171014_7"] = "Mercia's Legacy: Chapter Seven"
	AL["NOTE_171014_8"] = "Echo of Mercia"
	AL["NOTE_171211"] = "You have to use a [Fragile Humility Scroll] to start the combat."
	AL["NOTE_171211_1"] = "You might find a [Fragile Humility Scroll] here"
	AL["NOTE_171255"] = "It is neutral until you talk to him."
	AL["NOTE_171300"] = "He is underground. Inside the chamber there is a friendly NPC named [Malfunctioning Clawguard]. You have to find a [Discarded Phalynx Core] to turn him into the rare NPC. You can find the core hidden in the same room or around the [Forgefire Outpost]. It is a small blue round looking device."
	AL["NOTE_171300_1"] = "Spot where you might find a [Discarded Phalynx Core]"
	AL["NOTE_171327"] = "Use the teleport to reach there."
	AL["NOTE_171337"] = "Be the first one to kill the fly and get the loot!"
	AL["NOTE_171475"] = "In order to interact with the treasure, use the [Faerie Lamp] and come back in 1 minute."
	AL["NOTE_171475_1"] = "Faerie Lamp"
	AL["NOTE_171484"] = "Grab the [Aromatic Flowers] (the arome lasts 10 minutes) and use the [Bounding Shroom] to reach to the top of the tree. Then use the [Incense Burner] to attract the moth."
	AL["NOTE_171688"] = "He is in a cave. Go to the top of the hill and follow the river, then jump down the waterfall. The entrance to the cave is behind the second waterfall."
	AL["NOTE_171688_1"] = "Jump down the waterfall"
	AL["NOTE_171699"] = "As soon as you approach it will dissappear, in order to reach to him, go to the beginning of the maze and follow the dots. Then you only have to defeat to [Shizgher]."
	AL["NOTE_171699_1"] = "Step on this to get invisible"
	AL["NOTE_172577"] = "You need to collect [Eurydea's Amulet] from [Eurydea's Necklace] to unlock the rare NPC."
	AL["NOTE_172577_1"] = "Eurydea's Necklace"
	AL["NOTE_172862"] = "Follow him to a cave where you will be able to attack him."
	AL["NOTE_173449"] = "You can use the spell [Door of Shadows] (from [Venthyr] covenant) to reach it, but before you do, take the [Forbidden Ink] from the bottom floor (on top of a table). You will need the ink to interact with the quill."
	AL["NOTE_173468"] = "You have to assist this NPC for six days and bring him different items every day. Day1: 8x[Handful of Oats] (get them from [Sacks of Oats] in the northern farms in Westfall), Day2: 1x[Grooming Brush], Day3: 4x[Sturdy Horseshoe], Day4: 1x[Bucket of Clean Water], Day5: 1x[Comfortable Saddle Blanket], Day6: 3x[Dredhollow Apple]. Important: This NPC is up only for 5 minutes, so you should collect all this items before you find him."
	AL["NOTE_173468_1"] = "Day1: Go to Westfall and look for [Sacks of Oats] in the northern farms."
	AL["NOTE_173468_2"] = "Day2: Speak to [Snickersnee], he will give you the [Grooming Brush]."
	AL["NOTE_173468_3"] = "Day3: Look for [Discarded Horseshoe] along these roads."
	AL["NOTE_173468_4"] = "Day4: Pick up [Empty Water Bucket] (beside the carriage) and fill it in Bastion or Ardenweald."
	AL["NOTE_173468_5"] = "Day5: Buy 1x[Comfortable Saddle Blanket] from [Ta'tru]."
	AL["NOTE_173468_6"] = "Day6: Buy 3x[Dredhollow Apple] from [Mims]."
	AL["NOTE_173488"] = "You have to pay 99x[Infused Ruby]. This coin is obtained completing world quests and killing mobs around the Halls of Atonement."
	AL["NOTE_173704"] = "You have to spend 30x[Infused Ruby]. This coin is obtained completing world quests and killing mobs around the Halls of Atonement."
	AL["NOTE_177336"] = "It is in a cave."
	AL["NOTE_178508"] = "Inside a building."
	AL["NOTE_178778"] = "If it's buried you have to break 5x[Bulging Root] to activate it."
	AL["NOTE_178778_1"] = "Bulging Root"
	AL["NOTE_179043"] = "It shares spawn spot with [Overgrown Helicid], so kill this NPC to force respawning."
	AL["NOTE_179464"] = "After this event [Konthrogz the Obliterator] will show up."
	AL["NOTE_179565"] = "This NPC requires nameplates on to be scannable by RareScanner. As soon as you attack him he will start running and you cannot stun him."
	AL["NOTE_179684"] = "You have to find to [Caretaker Kah-Kay] to start an event that will end up spawning him."
	AL["NOTE_179684_1"] = "[Caretaker Kah-Kay]."
	AL["NOTE_179755"] = "This is the non-elite rare version. The non-rare version has to reach 10 stacks to become non-elite rare."
	AL["NOTE_179759"] = "[Towering Exterminator] will shop up after this event."
	AL["NOTE_179768"] = "This is the elite rare version. The normal rare version has to reach 40 stacks to become elite."
	AL["NOTE_179769"] = "This is the non-rare version."
	AL["NOTE_179772"] = "In order to unlock it you have to collect 3x[Spectral Keys]."
	AL["NOTE_179779"] = "This is the liberated version."
	AL["NOTE_179791"] = "This is the imprisoned version. You can free him using the [Lock control]s to open the gates."
	AL["NOTE_179791_1"] = "Lock control"
	AL["NOTE_179802"] = "You have to buy a [Teleporter Repair Kit] from [Archivist Roh-Suir] and use it on the [Ancient Teleporter] to access its chamber."
	AL["NOTE_179823"] = "This NPC requires nameplates on to be scannable by RareScanner. As soon as you attack him he will start running and you cannot stun him."
	AL["NOTE_179859"] = "You have to buy a [Teleporter Repair Kit] from [Archivist Roh-Suir] and use it on the [Ancient Teleporter] to access its chamber."
	AL["NOTE_179883"] = "Only visible when using the item [Unbalanced Riftstone] that is part of the quest [A Shady Place] or using the item [Repaired Riftkey] on a [Rift Portal] in Korthia and walking all the way here. Bring it to [Ve'nari] to unlock it."
	AL["NOTE_179883_1"] = "Ve'nari"
	AL["NOTE_179912"] = "This NPC requires nameplates on to be scannable by RareScanner. You have to find her and click on her for six days in total."
	AL["NOTE_179931"] = "In order to reach its position you have to advance in the campaign and unlock the [Grappel points]. Once you start the combat he will keep jumping from island to island until he reaches the main continent where you can kill him. So if you haven't unlock these [Grapple points] you can wait for another player to attack him."
	AL["NOTE_179931_1"] = "You will be able to attack him here."
	AL["NOTE_179969"] = "You have to defend the venthyr crew while they repair the [Broken Gatecrasher] and then [Stygian Stonecrusher] will show up. Only [Venthyr] players can start this event."
	AL["NOTE_179985"] = "He appears once the [Broken Gatecrasher] is repaired."
	AL["NOTE_180013"] = "This is the version that you can attack. Only [Night Fae] players can start this event."
	AL["NOTE_180014"] = "This is the version that you can ride after you defeat it."
	AL["NOTE_180028"] = "Help him and he will summon [Wild Worldcracker]. Only [Kyrian] players can start this event."
	AL["NOTE_180028_1"] = "Wild Worldcracker"
	AL["NOTE_180032"] = "You have to help [Popo] to summon him."
	AL["NOTE_180032_1"] = "Popo"
	AL["NOTE_180042"] = "He appears after completing the event [Corpse Heap]."
	AL["NOTE_180064"] = "Once you complete this event [Fleshwing] will show up. Only [Necrolord] players can start this event."
	AL["NOTE_180144"] = "This is the entrance to the chamber where you will find [Yarxhov the Pillager]"
	AL["NOTE_180145"] = "This is the entrance to the chamber where you will find [Xyraxz the Unknowable]"
	AL["NOTE_180160"] = "In order to attack him you have to interact with [Uncorrupted razorwing egg] so he comes closer to you."
	AL["NOTE_180160_1"] = "Uncorrupted razorwing egg"
	AL["NOTE_180162"] = "You will find an [Abandoned Veilstaff] in its position. Use it to summon him."
	AL["NOTE_180246"] = "He appears while the event [Assault Supply Carriage] is active. With this event you will find a carriage wandering around [The Maw]s roads, it will stop in this spot and this NPC will spawn."
	AL["NOTE_180246_1"] = "The event [Assault Supply Carriage] starts here."
	AL["NOTE_180273"] = "In order to get the [Sorrowbane] the world quest [A Few Bumps Along the Way] has to be up!. If it is, then talk to the innkepper at The Theater of Pain and make it your new home. Then buy 1x[Strength of Blood] from Ta'tru (in Revendreth 51.78), buy 1x[Potion of Unusual Strength], get 2x[Battle Hardened] and collect 4x[Edible Redcap]. Your movement will be reduced a 80%, thats why you have to use your hearthstone back to the Inn, mount up and go as fast as you can to the Sword, drink all the potions and pick up the sword before the buffs go away."
	AL["NOTE_180273_1"] = "Go to Revendreth [51.78] and buy 1x[Strength of Blood] from Ta'tru"
	AL["NOTE_180273_2"] = "Buy 1x[Potion of Unusual Strength] from Au'larrynar"
	AL["NOTE_180273_3"] = "Requires the world quest [A Few Bumps Along the Way]. Get 2x[Battle Hardened]"
	AL["NOTE_180293"] = "When this event is active there is a chance for [Carriage Crusher] to spawn in one of the carriage stops."
	AL["NOTE_180645"] = "You have to find 5x[Playful Vulpin] around Ardenweald. They will interact with you, and depending on their actions you have to answer with an emote. 'begins to dig curiously' [/curious], 'wanders around unable to sit still' [/sit], 'sings all alone' [/sing], 'dances with joy' [/dance], 'sits down lonely and sad' [/pet]"
	AL["NOTE_180731"] = "In order to see the treasure you have to find 5 items at the [Garden of Night] and use them to create [Twinklestar's Gardening Toolkit]. Then come back and talk to [Twinklestar] (fairy beside this treasure)."
	AL["NOTE_180731_1"] = "Top platform, on top of a table"
	AL["NOTE_180731_2"] = "In the middle of the cart"
	AL["NOTE_180731_3"] = "Between the two big stones"
	AL["NOTE_180731_4"] = "On the ground beside the two flower buds"
	AL["NOTE_180731_5"] = "Under the cart, between the wheels"
	AL["NOTE_180746"] = "It requires two players to open the door. Each player has to get a [Mysterious Cypher]s that match the ones on the side of the door and stand beside it at the same time."
	AL["NOTE_180746_1"] = "[Mysterious Cypher]"
	AL["NOTE_180978"] = "Fish 1x[Strange Goop] in the waters above the NPC. Talk to [Baroness Vashj] in Maldraxxus. Then bring her three more items to craft an [Aurelid Lure] to fish [Hirukon]. Items: [Pungent Blobfish] in Zangarmarsh/Outland, [Flipper Fish] in Nazjatar and [Coilclutch Vine] in Shimmering Expanse/Vashj'ir. Enable the guidance icons to see the positions in each map."
	AL["NOTE_180978_1"] = "Fish 1x[Strange Goop] here. Once you have the [Aurelid Lure] come back to the same spot, use it and fish in the [Aurelid Cluster] that will appear to trigger [Hirukon]."
	AL["NOTE_180978_2"] = "Talk to [Baroness Vashj] carrying the [Strange Goop], collect the three items, and bring them back."
	AL["NOTE_180978_3"] = "Fish it from a [Pungent Blobfish Cluster] (at the entrance of [Coilfang Reservoir])."
	AL["NOTE_180978_4"] = "Fish a [Flipper Fish] from a [Flipper Fish School] and catch it from the ground as soon as it slips away from your hands."
	AL["NOTE_180978_5"] = "Go to the top floor of the ruins and then move to the first floor right underneath. You will find a tower covered in green plants, there is a [Coilclutch Vine] on the floor of the top balcony (is a green ball, the same shade of green as the plants on the ground, so it's hard to see)."
	AL["NOTE_181164"] = "There is a [Oonar's Arm] attached to the handle of [Sorrowbane]. In order to get it talk to the innkeeper at The Theater of Pain and make it your new home. Then collect 4x[Edible Redcap]. Your movement will be reduced to 80%, thats why you have to use your hearthstone back to the Inn, mount up and go as fast as you can to the Sword and pick up the arm before the buff goes away."
	AL["NOTE_181164_1"] = "Slumbar Valorum <Innkeeper>"
	AL["NOTE_181164_2"] = "Edible Redcap"
	AL["NOTE_183516"] = "He will appear after defending [The Matriarch]."
	AL["NOTE_183646"] = "Open the [Suspiciously Angry Vault] to summon [Furidian]. To open it, you have to find 3x[Empowered key]."
	AL["NOTE_183646_1"] = "Star Empowered Key"
	AL["NOTE_183646_2"] = "Cube Empowered Key"
	AL["NOTE_183646_3"] = "Orb Empowered Key"
	AL["NOTE_183764"] = "Hit some [Menacing Vespoid Worker]s (flying bugs) that are right beside, and without killing them, wait until you get 20x[Paralytic Sting]."
	AL["NOTE_183925"] = "Use the [Locus Shift teleport] and select [Ultimus Locus Arrangement] to reach to its position."
	AL["NOTE_183925_1"] = "Transport to [Ultimus Locus Arrangement]"
	AL["NOTE_185285_1"] = "Coreless Aurelid"
	AL["NOTE_280951"] = "Follow the railway until you find a cart. Ride it to discover the treasure."
	AL["NOTE_287239"] = "If you are horde you have to complete Vol'dun campaign in order to have access to the temple."
	AL["NOTE_289647"] = "The treasure is in a cave. The entrance is at the coordinates 65.11, between some trees almost on top of the mountain."
	AL["NOTE_292673"] = "1 of 5 scrolls. Read all of them to discover the treasure [Secret of the Depths]. It is in the basement. Hide this icon manually once you read it."
	AL["NOTE_292674"] = "2 of 5 scrolls. Read all of them to discover the treasure [Secret of the Depths]. It is under the wood floor, in the corner beside a bunch of candles. Hide this icon manually once you read it."
	AL["NOTE_292675"] = "3 of 5 scrolls. Read all of them to discover the treasure [Secret of the Depths]. It is in the basement. Hide this icon manually once you read it."
	AL["NOTE_292676"] = "4 of 5 scrolls. Read all of them to discover the treasure [Secret of the Depths]. It is in the top floor. Hide this icon manually once you read it."
	AL["NOTE_292677"] = "5 of 5 scrolls. Read all of them to discover the treasure [Secret of the Depths]. It is in an underground cave. The entrance is under water at the coordinates 72.40 (water pool at the monastery). Hide this icon manually once you read it."
	AL["NOTE_292686"] = "After reading the 5 scrolls, use the [Ominous Altar] to obtain [Secret of the Depths]. Warning: Using the altar will teleport you to the middle of the sea. Hide this icon manually once you use it."
	AL["NOTE_293349"] = "It is inside the shed, on top of a shelf."
	AL["NOTE_293350"] = "This treasure is hidden in a cave underneath. Go to the coordinates 61.38, and set the camera on top, then jump backwards through the little crack on the floor and land on the ledge."
	AL["NOTE_293852"] = "You won't see this until you collect [Soggy Treasure Map] from the pirates at Freehold"
	AL["NOTE_293880"] = "You won't see this until you collect [Fading Treasure Map] from the pirates at Freehold"
	AL["NOTE_293881"] = "You won't see this until you collect [Yellowed Treasure Map] from the pirates at Freehold"
	AL["NOTE_293884"] = "You won't see this until you collect [Singed Treasure Map] from the pirates at Freehold"
	AL["NOTE_297828"] = "The raven flying on top holds the key. Kill it."
	AL["NOTE_297891"] = "You have to disable the runes in this order: Left, Down, Up, Right"
	AL["NOTE_297892"] = "You have to disable the runes in this order: Left, Right, Down, Up"
	AL["NOTE_297893"] = "You have to disable the runes in this order: Right, Up, Left, Down"
	AL["NOTE_326395"] = "You have to enable the [Arcane device] that is found on top of a table beside the chest in order to start the minigame. To pass the game you have to separate the three triangles. Click on the orbs to switch their positions."
	AL["NOTE_326396"] = "You have to enable the [Arcane device] that is found on the ground beside the chest in order to start the minigame. To pass the game you have to separate the two rectangles. Click on the orbs to switch their positions."
	AL["NOTE_326397"] = "You have to enable the [Arcane device] that is found on the ground beside the chest in order to start the minigame. To pass the game you have to line up three red runes."
	AL["NOTE_326398"] = "You have to enable the [Arcane device] that is found on top of a table beside the chest in order to start the minigame. To pass the game you have to line up four cyan runes."
	AL["NOTE_326399"] = "It's in a cave underwater. You have to complete a minigame where you have to shoot the fire balls before they touch the circles on the ground. Everytime a ball touches the ground or you use the spell without hitting a ball, the energy will decrease, and if it reaches zero then you will have to start again."
	AL["NOTE_326400"] = "It is in a cave. You have to complete a minigame where you have to shoot the fire balls before they touch the circles on the ground. Everytime a ball touches the ground or you use the spell without hitting a ball, the energy will decrease, and if it reaches zero then you will have to start again."
	AL["NOTE_326403"] = "It is inside the building. You have to access it from the back."
	AL["NOTE_326405"] = "It is between some ruins in the highest level of the map."
	AL["NOTE_326406"] = "It is on top of a mountain in the highest level of the map. It's hard to get there on foot, but it's possible from the south side."
	AL["NOTE_326407"] = "It is on top of a mountain in the highest level of the map."
	AL["NOTE_326408"] = "It is in a cave underwater. The entrance is in the lake to the south (coordinates 57,39)."
	AL["NOTE_326410"] = "It is in a cave in the lower level of the map."
	AL["NOTE_326411"] = "It is between some stones in the highest level of the map."
	AL["NOTE_326413"] = "It is in a cave in the lower level of the map."
	AL["NOTE_326415"] = "It requires flying or you can use a [Goblin Glider Kit] from the tall mountain beside. The chest is on top of the coral bridge."
	AL["NOTE_326416"] = "It is in the highest level of the map, inside a tower in ruins."
	AL["NOTE_329783"] = "It is on the roof (access at coordinates 83.33). You have to complete a minigame where you have to shoot the fire balls before they touch the circles on the ground. Everytime a ball touches the ground or you use the spell without hitting a ball, the energy will decrease, and if it reaches zero then you will have to start again."
	AL["NOTE_332220"] = "You have to complete a minigame where you have to shoot the fire balls before they touch the circles on the ground. Everytime a ball touches the ground or you use the spell without hitting a ball, the energy will decrease, and if it reaches zero then you will have to start again."
	AL["NOTE_336428"] = "It appears after defeating Herculon."
	AL["NOTE_339601"] = "In order to make this treasure appear you have to grab 2x[Purian], use them in the [tributes plate]s and come back to this position."
	AL["NOTE_339601_1"] = "Grab 2x[Prunes]"
	AL["NOTE_339601_2"] = "Tribute plate"
	AL["NOTE_339625"] = "Appears after defeating [Nikara Blackheart]"
	AL["NOTE_341424_1536"] = "This is the entrance to the vault where the treasure is. Come inside for more instructions."
	AL["NOTE_341424_1649"] = "In order to open the door you have to pull a chain that is hanging at the coordinates 25.53 in this vault."
	AL["NOTE_349794"] = "Behind the building, you can go around from the left side."
	AL["NOTE_349795"] = "It is on top of a wall, you need to use the [Bounding Shroom] to reach there."
	AL["NOTE_351487"] = "You have to pull the [Flickering Candle] to open the trapdoor."
	AL["NOTE_351487_1"] = "Flickering Candle"
	AL["NOTE_351540"] = "Grab [Dredger's Hammer] and use it on the left door of the building where you will find this treasure."
	AL["NOTE_351540_1"] = "Dredger's Hammer"
	AL["NOTE_351541"] = "It is underground, behind a bookshelf in the room to the right. You have to pull the [Nondescript Book] that you will find in the middle shelf to find the treasure."
	AL["NOTE_351542"] = "Break the crate to access the wheel to open the trap door."
	AL["NOTE_351542_1"] = "Crate to break"
	AL["NOTE_351543"] = "Use the [Hanging Chain] that is hanging from the balcony on top of the treasure, and open the little chest on top of the table to obtain the ring. Give the ring to the [Treasure Guardian] to unlock the treasure."
	AL["NOTE_351544"] = "It is underground. You have to interact with a portrait in the room right in front of the room where the treasure is. Behind the portrait you will find a lever to open the gates."
	AL["NOTE_351544_1"] = "Portrait"
	AL["NOTE_351545"] = "It is on top of a tree, but behind it there are some steps on the left side, you can jump to reach up. The prisoner will ask you to bring him a book in exchange for his treasure. The book is in the cages around where there are some prisoners. They won't let you loot the item unless you do it from behind the pole where their cage is hanging from."
	AL["NOTE_351980"] = "On top of the mushroom"
	AL["NOTE_351980_1"] = "Jump to the mushroom"
	AL["NOTE_351980_2"] = "Jump to the spider web"
	AL["NOTE_351980_3"] = "Go up this side"
	AL["NOTE_353331"] = "It is on the roof, you need to use the [Bounding Shroom] to reach there"
	AL["NOTE_353332"] = "It is on top of the wood side of the tree, you need to use the [Bounding Shroom] to reach there."
	AL["NOTE_353333"] = "It is on top of the tree, you need to use the [Bounding Shroom] to reach there."
	AL["NOTE_353336"] = "It is on top of a tree, but behind it there are some steps on the left side, you can jump to reach up. The prisoner will ask you to bring him a book in exchange for his treasure. The book is in the cages around where there are some prisoners. They won't let you loot the item unless you do it from behind the pole where their cage is hanging from."
	AL["NOTE_353643_1"] = "Jump from here"
	AL["NOTE_353650_1533"] = "Talk to [Elios] to know who is the special steward of the day (it will appear with a red flag in the worldmap). Go to that position and give him a [Ripe Purian] (fruit that you can find on top of tables all around Bastion)."
	AL["NOTE_353691"] = "It is in the wall of the mountain. You can reach the path jumping from the platform."
	AL["NOTE_353871_1533"] = "It is underground. In order to reach there, go to the beginning of the path and start going down walking along the right wall."
	AL["NOTE_353876"] = "You have to interact with [Burden of Penitence] and reach the treasure before 2 minutes."
	AL["NOTE_353876_1"] = "Burden of Penitence"
	AL["NOTE_353940"] = "This container is the [Gift of Vesiphone] part of the achievement. In order to unlock it, ring one of the [Bells of Purification] and then stand under the waterfall."
	AL["NOTE_353940_1"] = "Bell of Purification"
	AL["NOTE_353940_2"] = "Waterfall"
	AL["NOTE_353941"] = "This container is the [Gift of Churys] part of the achievement. It is on the platform in the air. Once you are in front of the treasure, stand on the gray plate on the ground and '/kneel' to unlock it."
	AL["NOTE_353942"] = "This container is the [Gift of Agthia] part of the achievement. In order to reach it, take a torch and use the [Agthia's Flame] until you reach the treasure"
	AL["NOTE_353942_1"] = "Agthia's Flame"
	AL["NOTE_353943"] = "In order to unlock the treasure you have to use the incenses in this order: [Patience], [Knowledge], [Insight] and [Judgement] (don't use the [Incense of Judgement], use an orb that appears on the edge of the platform)."
	AL["NOTE_353943_1"] = "Incense of Patience"
	AL["NOTE_353943_2"] = "Incense of Knowledge"
	AL["NOTE_353943_3"] = "Incense of Insight"
	AL["NOTE_353943_4"] = "Path of justice (DON'T USE THE INCENSE)"
	AL["NOTE_353943_5"] = "Incense of Judgement"
	AL["NOTE_353944"] = "This container is the [Gift of Devos] part of the achievement. You will need help to open this treasure (legally). In order to unlock it you need to bring the [Flame of Devotion] to the [Brazier of Devotion] right beside the chest. The issue is that you cannot use your mount while carrying the flame and if you get any kind of damage it will be extinguished. You can do the whole path by yourself, but the room where the treasure is will be guarded by a group of NPCs, so somebody else will have to kill them for you (unless... you go around the building where the brazier is at the other side of the wall, move the camera to the top so you can see it and then click on it)."
	AL["NOTE_353944_1"] = "Flame of Devotion"
	AL["NOTE_353944_2"] = "Follow the dots"
	AL["NOTE_353944_3"] = "Move the camera up and find the Brazier through the hole"
	AL["NOTE_354109"] = "It is on top of a wall. In order to reach there take the elevator and while it is going up, jump in diagonal in the direction of this treasure."
	AL["NOTE_354109_1"] = "Elevator"
	AL["NOTE_354109_2"] = "You have to fall here"
	AL["NOTE_354186"] = "It is on top of the wall, but in order to reach there you have to jump from a higher wall."
	AL["NOTE_354192"] = "It is on top of the mountain. Once you are at the top, in a little town, go to the right and jump from there."
	AL["NOTE_354202"] = "It is underground."
	AL["NOTE_354214"] = "It is underground."
	AL["NOTE_354275"] = "You have to find an [Unstable Construct Anima] to unlock it. It looks like a small blue/purple canister, and it is between the boxes and the big blue canisters around the area."
	AL["NOTE_354275_1"] = "You might find an [Unstable Construct Anima] here"
	AL["NOTE_354289"] = "This container is the [Windsmith's Tools] part of the achievement. You have to kill [Unsettled Etherwyrm] that are flying near the treasure to loot [Broken Kyrian Flute]. You will use this item to unlock the chest."
	AL["NOTE_354646"] = "This container is the [Veilwing egg] part of the achievement. It is in a nest on top of the branches."
	AL["NOTE_354647"] = "On top of a branch. Go to the top of the waterfall and there you will find a [Dragon Plume]. Use it to fall slowly and land on the branch where the treasure is."
	AL["NOTE_354647_1"] = "Dragon Plume"
	AL["NOTE_354648"] = "Inside the tree. You have to access from the top. Jump on the [Bounding Shroom] to reach it"
	AL["NOTE_354649"] = "[Demi the Relic Hoarder] drops this treasure when you defeat him."
	AL["NOTE_354650"] = "On top of the tree hanging on the tip of a branch. Jump on the [Bounding Shroom] to reach it"
	AL["NOTE_354651"] = "It is hanging from the top branch in the middle of the arch. You can reach it by climbing the rocks on the left from behind."
	AL["NOTE_354662"] = "In order to interact with the treasure, use the [Faerie Lamp] and come back in 1 minute."
	AL["NOTE_354856"] = "As soon as you approach the area you will get stacks of the debug [Caustic Fog] that will increase the Nature damage taken. Avoid stepping in the water unless you have a big damage reduction spell."
	AL["NOTE_354859"] = "It's the reward for defeating [Echo of Aella]"
	AL["NOTE_355286"] = "You have to buy a [Memorial Wine] from [Kobri] (he appears in the rest points but keeps changing positions, start taking a look in Hero's Rest). Once you have the wine use it on the [Drink Tray]. You will receive the key to open the chest."
	AL["NOTE_355286_1"] = "You might find [Kobri] here"
	AL["NOTE_355286_2"] = "Drink Tray"
	AL["NOTE_355358"] = "You cannot open it alone! In order to open it, one person has to play the [Fae Harp] and another person has to play the [Fae Drums] at the same time."
	AL["NOTE_355418"] = "Inside the tree. You have to access from the middle. Use the ramp to reach it. You have to gather three items to craft [Fae Dreamcatcher] and use it to remove the barrier."
	AL["NOTE_355418_1"] = "On the top platform"
	AL["NOTE_355418_2"] = "Under the platform"
	AL["NOTE_355418_3"] = "On the top platform, hanging from the tree"
	AL["NOTE_355435"] = "You need to gather 50x[Anima Crystal Shard]s around Bastion. There are 5 shards in dungeons: Necrotic Wake [52.88, 36.22] and Spires of Ascension [Gardens-46.53, Gardens-69.38, Font-49.46] Then go to talk to [Forgelite Hephaesius] to craft [Crystal Mallet of Heralds]. Use this item to unlock the treasure."
	AL["NOTE_355435_1"] = "Anima Crystal Shard"
	AL["NOTE_355435_1a"] = "Anima Crystal Shard (underground, entrance at 55.43)"
	AL["NOTE_355435_1b"] = "Anima Crystal Shard (underneath, path at 51.47)"
	AL["NOTE_355435_1c"] = "Anima Crystal Shard (on top of the building, you need something to fly there)"
	AL["NOTE_355435_2"] = "Forgelite Hephaesius"
	AL["NOTE_355865"] = "On top of the table to the right there is a little bottle. Use it on the chest to open it."
	AL["NOTE_355880"] = "This container is the [Necro Tome] part of the achievement. It is in the top floor of the tower. In order to open it you have to complete the series of quests that gives you [Ta'eran]."
	AL["NOTE_355880_1"] = "Ta'eran"
	AL["NOTE_355886"] = "Step in green water and get 10 stacks of [Concentrated Plague] that will turn you into a hideous monster. Once you're a monster use the [Pipe] to reach the treasure."
	AL["NOTE_355886_1"] = "Step in the water here"
	AL["NOTE_355886_2"] = "[Pipe] under the platform"
	AL["NOTE_355947"] = "It is in a cave. You have to kill the two non elite NPCs beside it to unlock it."
	AL["NOTE_355980"] = "In order to interrupt the ritual, collect the [Missing Ritual Pages] (in the corner of the room) and use them on the [Book of Binding Rituals] (on the bookshelf)."
	AL["NOTE_356535"] = "You need the [Phaeton's Key] to open it. The holder of the key is [Runespeaker Phaeton]."
	AL["NOTE_356535_1"] = "Phaeton's Key"
	AL["NOTE_356823"] = "Jump on the flowers to reach its position."
	AL["NOTE_357487"] = "On top of the wall."
	AL["NOTE_358040"] = "This chest appears after defeating [Sinstone Hoarder]."
	AL["NOTE_358292"] = "When you open it the real [Taskmaster's Trove] appears. You have to avoid the balls to reach its position."
	AL["NOTE_358298"] = "Go inside the tower and turn left. On top of a bench there is an [Anima Canister], take it and use it on [Silent Observer]s (friendly imps inside the tower; use \"/tar silent\" to find them). Then return to the door right beside the bench where you took the canister and use the new button to open the door."
	AL["NOTE_368653"] = "It requires a [Etherwyrm Cage Key] dropped by [Elusive keybinder]s that are in the area (visible only while using the item [Unbalanced Riftstone] that is part of the quest [A Shady Place])."
	AL["NOTE_369148"] = "On the wall of the mountain."
	AL["NOTE_369148_1"] = "Jump down from here."
	AL["NOTE_369149_1"] = "Jump down here to reach the island."
	AL["NOTE_369183"] = "It is hanging from a branch on the tree. Find a [Noxious Moth] to get the buff [Baiting]. With the buff on, use the extra button on a [Shardhide bear] to ride it. Once you are riding the bear, run into the tree and the container will fall."
	AL["NOTE_369183_1"] = "Noxious Moth"
	AL["NOTE_369200"] = "It appears after unlocking [Spectral Bound Chest]."
	AL["NOTE_369225"] = "It is in a cave."
	AL["NOTE_369232"] = "You need a [Small Offering Key] to open it."
	AL["NOTE_369232_1"] = "On top of the triangular wall."
	AL["NOTE_369262"] = "It apppears after bringing [Zovaal's Vault] to this position."
	AL["NOTE_369262_1"] = "Zovaal's Vault"
	AL["NOTE_369435"] = "Interact with this object to call [Reliwik the Defiant]."
	AL["NOTE_369757"] = "Grab the [Dangerous Orb of Power] and use it with the [Forgotten Pump] to bring the treasure to the surface."
	AL["NOTE_369757_1"] = "[Dangerous Orb of Power]"
	AL["NOTE_369757_2"] = "[Forgotten Pump]"
	AL["NOTE_373543"] = "In a cave. Interact with the [Tablet] to unlock it"
	AL["NOTE_373543_1"] = "[Tablet]. Inside the cave."
	AL["NOTE_373548"] = "Inside a building. In order to open the door to the treasure, use the [Orb]."
	AL["NOTE_373548_1"] = "Orb"
	AL["NOTE_373561"] = "Only accessible with a flying mount, with warlock portals (or similar) or while the world quest [Frog'it] is active."
	AL["NOTE_373568"] = "You need the key [Provis Cache Key] to open it. In order to create the key, use [Firim's Spare Forge-tap] in the copper orbs around Zereth Mortis to extract 15x[Ephemera Strands] and create an [Ephemera Orb]. This last item has a chance to contain the key."
	AL["NOTE_373568_1"] = "Talk to [Firim] to get a [Firim's Spare Forge-tap]. He will give you the item only after you have completed the random daily quest [Hollow efforts] or [Materials of Creation] at least once."
	AL["NOTE_373568_2"] = "Entrace to the cave of [Firim]"
	AL["NOTE_373579"] = "Only reachable with a flying mount"
	AL["NOTE_374976"] = "Touch the [Broken Console]s in the correct order [1-2-1-3-4]. Enable the guide icons and zoom in to see them in your minimap."
	AL["NOTE_375281"] = "It is on top of a nest. In order to reach it you have to use the floating spheres, jumping from one to another."
	AL["NOTE_375354"] = "You need a [Dominance Key] to open it. They key is dropped by [Mawsworn Inquisitor]s in the area (low drop rate)."
	AL["NOTE_375369"] = "On the roof. In order to reach it start climbing up the side of the triangular gate."
	AL["NOTE_375376"] = "Jump down the cliff. Once you get it use the [Forgotten Translocator] that is beside to get back to the top of the cliff."
	AL["NOTE_375382"] = "Take the [Repair Tool] (on the big pillar right above the treasure, beside a small rock; it's very small). Then give it to [Hiu Fi]. He will give you a [Jiro Hammer] to break the stones where it's trapped."
	AL["NOTE_375382_1"] = "Hiu Fi"
	AL["NOTE_375404"] = "You need a [Sandworn Chest Key] to open it. The key is built with 5x[Sandworn Chest Key Fragments] dropped by all the mobs around [Arrangement Index]."
	AL["NOTE_375405"] = "In a nest on top of the tree. You have to climb the orbs to reach there (and have a lot of patience)"
	AL["NOTE_375408"] = "Research [Sopranian Understanding] at [Cypher Console] to unlock the quest [Finding Tahli] started by [Elder Amir]. Complete the whole series of quests and then you will be able to go inside the building where the treasure is and interact with it."
	AL["NOTE_375408_1"] = "[Elder Amir]"
	AL["NOTE_375411"] = "Inside a cave. You have to collect 5x[Lost Ovoid]s around the green areas in Zereth Mortis. Then come back and return them to [Frazzledl Poultrid Hen]. It will move aside, letting you get the treasure."
	AL["NOTE_375411_1"] = "You might find a [Lost Ovoid] here."
	AL["NOTE_375413"] = "Research [Dealic Understanding] at [Cypher Console] and use [Pocopoc] to interact with [Coreless Aurelid] to reach the treasure."
	AL["NOTE_375478"] = "Use the [Locus Shift teleport] and select [Secundus Locus Arrangement]. Then you have to jump to the platform on the right side."
	AL["NOTE_375478_1"] = "Transport to [Secundus Locus Arrangement]"
	AL["NOTE_375481"] = "Only accessible with a flying mount or with warlock portals and similar."
	AL["NOTE_375483"] = "It is on top of the pillar. In order to reach it, start climbing up the side of the triangular gate."
	AL["NOTE_375484"] = "Only accessible with a flying mount or with warlock portals and similar. In order to be able to interact with the container, you have to pet 5x[Agitated Vombata]s, 4x[Agitated Cervid]s and 3x[Agitated Lupine]s that are on top of the mountain."
	AL["NOTE_375485"] = "On top of the tree. In order to reach it you have to jump from the mountain that is beside the tree."
	AL["NOTE_375485_1"] = "Mount up and jump down from here."
	AL["NOTE_375492"] = "In a cave. You have to find six [Runic Syllable]s to get 6x[Syllabic Recall] (the buff lasts 5 minutes but it refreshes with every new stack). Then interact with the [Syntatic Seal] beside."
	AL["NOTE_375492_1"] = "[Runic Syllable]"
	AL["NOTE_375493"] = "Inside the [Blooming Foundry]. Research [Sopranian Understanding] at [Cypher Console] to unlock the quest [Mysterious Greenery] started by [Glimmercane]. After completing these quests you will be able to go inside the building. Once inside, step on the dark green clouds around the area to get 1x[Pollen Cloud]. With the buff on, interact with the [Unripened Protopear]. Repeat five times to convert it to [Ripened Protopear]."
	AL["NOTE_375493_1"] = "[Glimmercane]"
	AL["NOTE_375495"] = "Inside a building. To reach the treasure you have to unlock 4x[Teleporter locks] and then use the [Teleporter]."
	AL["NOTE_375495_1"] = "Destroy the [Bloomthorn Vine] on the left and use [Catalyst Wards Lock]."
	AL["NOTE_375495_2"] = "[Teleporter lock]. Outside the building, right behind the [Catalyst Wards Lock]"
	AL["NOTE_375495_3"] = "[Teleporter lock]. Inside the building"
	AL["NOTE_375495_4"] = "[Teleporter]. Inside the building. Only visible after using the 4x[Telporter Lock]s."
	AL["NOTE_375496"] = "In order to be able to open the door you have to kill 5x[Nascent Servitor]. When they die you get the buff [Creation Catalyst Overcharge] (the buff lasts 40 seconds and the timer restarts with every new stack). Once you have five stacks you can interact with the door."
	AL["NOTE_375496_1"] = "[Nascent Servitor]"
	AL["NOTE_375530"] = "The most of these treasures are accessible only with a flying mount, so if you cannot reach it keep advancing in the campaign."
	AL["NOTE_ABUSE_POWER_NPCS"] = "You need to complete the series of quests that start with [An Abuse of Power] to be able to kill this NPC. Then complete the repeatable quest [%s] to obtain the item required to unlock him."
	AL["NOTE_ANIMA_CONDUCTOR"] = "You have to be a member of the [%s] Covenant. You have to unlock the [Anima Conductor] and channel it to [%s]. %s"
	AL["NOTE_ASCENDED_COUNCIL_NPCS"] = "This NPC forms part of the [Ascended Council]. You have to ring the five bells in a short period of time (few minutes) to start the event. You will have to fight all the champions. When you defeat them the [Cache of the Ascended] will appear."
	AL["NOTE_BOUNDING_SHROOM"] = "Use the [Bounding Shroom] to reach there."
	AL["NOTE_CACHEs_SWAGSNOUT_GROMIT"] = "RareScanner cannot alert you to this container. In order to find, you must buy a [Trained Gromit Carrier] from [Archivist Roh-Suir] and use it to summon a gromit. He will warn you every time he finds the container and highlight it with a blue light"
	AL["NOTE_CITADEL_LOYALTY"] = "Citadel of Loyalty"
	AL["NOTE_CITADEL_LOYALTY_NPCS"] = "Then you will be able to interact with the [Black Bell] to summon him."
	AL["NOTE_CRAFTING_NPCS"] = "You have to add materials to the pool until you complete 30/30. %s"
	AL["NOTE_DAFFODIL_NPCS"] = "Talk to [Daffodil] (fairy flying beside). It will make [Rotbriar Boggart] appear to kill him."
	AL["NOTE_DAPPERDEW_NPCS"] = "You have to be a member of the [Night Fae] Covenant. Talk to [Dapperdew] to start the event. Everyday, and for the whole day, one rare NPC will show up."
	AL["NOTE_DOMINANCE_KEEP"] = "Dominance Keep"
	AL["NOTE_FIRIM_EXILE"] = "Firim in Exile"
	AL["NOTE_FOUR_PEOPLE_NPCS"] = "It requires 4 people to summon him."
	AL["NOTE_GRAND_INQUISITOR"] = "Grand Inquisitor Sinstone"
	AL["NOTE_GRAPPLING_GROWTH_CONTAINERS"] = "You have to look for a [Grappling Growth] (they are on top of the mushrooms and show up in the minimap). You can click on them from the distance. Use them to reach the treasure."
	AL["NOTE_GREEDSTONE_CONTAINERS"] = "Touch the [Greedstone] and run to reach the treasure."
	AL["NOTE_HIGH_INQUISITOR"] = "High Inquisitor Sinstone"
	AL["NOTE_HOUSE_CONSTRICTS"] = "House of Constructs"
	AL["NOTE_INQUISITOR"] = "Inquisitor Sinstone"
	AL["NOTE_KYRIAN"] = "Kyrian"
	AL["NOTE_LUNARLIGHT_CONTAINERS"] = "You have to step on the 5x[Lunarlight Bud]"
	AL["NOTE_NECROLORDS"] = "Necrolords"
	AL["NOTE_NIGHT_FAE"] = "Night Fae"
	AL["NOTE_ORATOR_KLOE_NPCS"] = "You have to talk to [Orator Kloe] to start the event. Every time you talk to him a different rare NPC will show up, appearing in this order: [Aethon], [Cloudtail], [Nemaeus] and [Sigilback]."
	AL["NOTE_RIFT_HIDDEN_CONTAINERS"] = "Only visible when using the item [Unbalanced Riftstone] that is part of the quest [A Shady Place] or using the item [Repaired Riftkey] on a [Rift Portal] in Korthia and walking all the way here."
	AL["NOTE_RIFT_NPCS"] = "You have to buy a [Repaired Riftkey] from [Archivist Roh-Suir] or loot it from the caches you will find around Korthia. Use the key with a [Rift Portal] to enter [The Rift]."
	AL["NOTE_RIFT_NPCS_MAW"] = "You have to buy a [Repaired Riftkey] from [Archivist Roh-Suir]. Use the key with a [Rift Portal] to enter [The Rift]. Then walk all the way back here to find him."
	AL["NOTE_RIFT_PORTAL"] = "Rift portal"
	AL["NOTE_RIPE_PURIAN_CONTAINERS"] = "You have to bring a [Ripe Purian] and place it in the tribute bowl. An [Appreciative Steward] will show up and will give you a [Steward's Silver Key] to unlock the treasure."
	AL["NOTE_RUNE_CONSTRUCTS_CONTAINERS"] = "You have to disable 3x[Rune of constructs] that are around the area (they are tiles on the floors and walls). As soon as you disable the last one the chest will be unlock."
	AL["NOTE_STOLEN_ANIMA_VESSEL"] = "RareScanner cannot alert you to this container. In order to find, you must buy a [Vault Anima Tracker] from [Archivist Roh-Suir] and use it (without it you won't see this container)."
	AL["NOTE_STOLEN_ANIMA_VESSEL_RIFT"] = "RareScanner cannot alert you to this container. In order to find, you must buy a [Vault Anima Tracker] from [Archivist Roh-Suir] and use it (without it you won't see this container). Only visible when using the item [Repaired Riftkey] on a [Rift Portal] in Korthia and walking all the way here."
	AL["NOTE_SWELLING_TEAR_NPCS"] = "It appears only when the event [Swelling Tear] is active."
	AL["NOTE_TEMPLE_COURAGE"] = "Temple of Courage"
	AL["NOTE_THEATER_PAIN"] = "Theater of Pain"
	AL["NOTE_THEATER_PAIN_NPCS"] = "Start defeating enemies until you can attack this NPC."
	AL["NOTE_TIRNA_SCITHE"] = "Tirna Scithe"
	AL["NOTE_VENTHYR"] = "Venthyr"
	AL["NOTE_VESPER_REPAIR_NPCS"] = "You need to complete the event [Vesper Repair] with another 2 players. Each person will stand on top of one of the gray plates on the ground, and then enemies will start showing up in waves. The rare NPC might appear in the third wave."
	AL["NOTE_WANECRYPT_HILL"] = "Wanecrypt Hill"
	AL["PILE_BONES"] = "Pile of Bones"
	AL["PRE_EVENT"] = "Event: %s"
	AL["PROFILES"] = "Profiles"
	AL["RAIDS"] = "Raids"
	AL["RELIC_CACHE"] = "Relic Cache"
	AL["RESCAN_TIMER"] = "Timer to avoid constant alerts for the same entity"
	AL["RESCAN_TIMER_DESC"] = "Define the amount of time (in minutes) during which the addon won't alert you of the same entity if its found more than once in that period. You should increase the amount of time set if you find the frequency of alerts for the same entity annoying."
	AL["RESET_POSITION"] = "Reset position"
	AL["RESET_POSITION_DESC"] = "Restores the original position of the main button."
	AL["SHADOWLANDS_PRE_PATCH_NEXTSPAWN"] = "Shadowlands pre-patch event: %s will spawn next! Look for the pink skull on the map."
	AL["SHADOWLANDS_PRE_PATCH_SPAWNINGTIMER"] = "Respawn in (approx): %s"
	AL["SHARDHIDE_STASH"] = "Shardhide Stash"
	AL["SHOW_CHAT_ALERT"] = "Toggle showing chat alerts"
	AL["SHOW_CHAT_ALERT_DESC"] = "Shows a private message in the chat every time a treasure, chest or NPC is found"
	AL["SHOW_RAID_WARNING"] = "Toggle showing raid warnings"
	AL["SHOW_RAID_WARNING_DESC"] = "Shows a raid warning on your screen every time a treasure, chest or NPC is found"
	AL["SOUND"] = "Sound"
	AL["SOUND_ADD"] = "Add a custom sound"
	AL["SOUND_ADD_DESC"] = "Type the name of your custom sound. This is the name that you will see in the lists above."
	AL["SOUND_AUDIOS"] = "Sounds"
	AL["SOUND_CHANNEL"] = "Sound channel"
	AL["SOUND_CHANNEL_DESC"] = "Channel to play the audio alerts. Every channel except \"Master\" have user-configurable volume settings and may be muted."
	AL["SOUND_CUSTOM_FILE"] = "Sound file"
	AL["SOUND_CUSTOM_FILE_DESC"] = "Type the name of the sound file that you copied into your custom sounds folder. For example: 'myaudio.ogg'."
	AL["SOUND_CUSTOM_FILE_INFO"] = "Instructions"
	AL["SOUND_CUSTOM_FILE_INFO1"] = "1. Create the folder 'World of Warcraft\\_retail_\\Interface\\addons\\%s'"
	AL["SOUND_CUSTOM_FILE_INFO2"] = "2. Copy your audio file in OGG or MP3 format into the folder"
	AL["SOUND_CUSTOM_FILE_INFO3"] = "3. If you copied the file after loading the game, use the button '%s' to load the new audio file."
	AL["SOUND_CUSTOM_FILE_INFO4"] = "4. Type the name of the file and add it. For example 'myaudio.ogg'"
	AL["SOUND_CUSTOM_FILE_INFO5"] = "5. Now you can select the audio from the lists above"
	AL["SOUND_CUSTOM_FOLDER"] = "Custom sounds folder"
	AL["SOUND_CUSTOM_FOLDER_DESC"] = "Name of the folder inside 'World of Warcraft\\_retail_\\Interface\\addons\\' where you want to store your custom sound files."
	AL["SOUND_DELETE"] = "Delete"
	AL["SOUND_DELETE_DESC"] = "Deletes this custom sound"
	AL["SOUND_OPTIONS"] = "Sound options"
	AL["SOUND_PLAY"] = "Play"
	AL["SOUND_PLAY_DESC"] = "Plays this custom sound. If you cannot hear it, check the file path or try reloading your interface just in case the audio has not loaded yet."
	AL["SOUND_RELOAD"] = "Reload UI"
	AL["SOUND_RELOAD_DESC"] = "Reloads the interface. Use this button if you copied the audio file into 'RareScannerSounds' folder after loading the game."
	AL["SOUND_VOLUME"] = "Volume"
	AL["SOUND_VOLUME_DESC"] = "Sets the sound volume level. This doesn't apply to custom sounds."
	AL["STOLEN_ANIMA_VESSEL"] = "Stolen Anima Vessel"
	AL["TEST"] = "Launch Test"
	AL["TEST_DESC"] = "Press the button to show an alert example. You can drag and drop the panel to another position where it will be shown from now on."
	AL["TOC_NOTES"] = "Minimap scanner. Warns you visually with a button and a miniature and plays a sound everytime a rare NPC, treasure/chest or event shows up in your minimap"
	AL["TOGGLE_FILTERS"] = "Toggle filters"
	AL["TOGGLE_FILTERS_DESC"] = "Toggle all filters at once"
	AL["TOMTOM_WAYPOINTS"] = "Tomtom waypoints"
	AL["TOOLTIP_BOTTOM"] = "Lower side"
	AL["TOOLTIP_BOTTOMLEFT"] = "Lower left side"
	AL["TOOLTIP_BOTTOMRIGHT"] = "Lower right side"
	AL["TOOLTIP_CURSOR"] = "Follow cursor"
	AL["TOOLTIP_LEFT"] = "Left side"
	AL["TOOLTIP_RIGHT"] = "Right side"
	AL["TOOLTIP_TOP"] = "Upper side"
	AL["TOOLTIP_TOPLEFT"] = "Upper left side"
	AL["TOOLTIP_TOPRIGHT"] = "Upper right side"
	AL["UNKNOWN"] = "Unknown"
	AL["UNKNOWN_TARGET"] = "Unknown target"
	AL["ZONE_1332"] = "%s (Warfront)"
	AL["ZONE_1527"] = "%s (BFA Assault)"
	AL["ZONE_1530"] = "%s (BFA Assault)"
	AL["ZONE_1570"] = "%s (BFA Lesser vision of N'Zoth)"
	AL["ZONE_1571"] = "%s (BFA Lesser vision of N'Zoth)"
	AL["ZONE_317"] = "%s (Human side)"
	AL["ZONE_318"] = "%s (Undead side)"
	AL["ZONE_943"] = "%s (Warfront)"
	AL["ZONES_FILTER"] = "Zone filters"
	AL["ZONES_FILTERS_SEARCH_DESC"] = "Type the name of the zone to filter the list below"
	
	AL["NOTE_381712"] = "Defeat all the waves of elementals to unlock it."
	AL["NOTE_194270"] = "Use an [Arcane Energy] in the [Arcane Tome] to summon him."
	AL["NOTE_194270_1"] = "[Arcane Energy]"
	AL["NOTE_GLYPH_15988"] = "On top of the mountain"
	AL["NOTE_GLYPH_15991"] = "Under the arch, overhead"
	AL["NOTE_GLYPH_16051"] = "Inside the broken tower, top side"
	AL["NOTE_GLYPH_16100"] = "On top of the tower"
	AL["NOTE_GLYPH_15985"] = "On the air on top of the tower"
	AL["NOTE_GLYPH_15986"] = "On top of a short broken tower"
	AL["NOTE_GLYPH_16052"] = "On the highest peak of the mountain. This is the hardest spot to reach."
	AL["NOTE_GLYPH_15990"] = "On top of the dome"
	AL["NOTE_GLYPH_15989"] = "On top of a mountain"
	AL["NOTE_GLYPH_15987"] = "On top of a natural stone column"
	AL["NOTE_GLYPH_16053"] = "On the air above a lava pool"
	AL["NOTE_GLYPH_16062"] = "On the air above the tower"
	AL["NOTE_GLYPH_16054"] = "Above a statue on top of the mountain"
	AL["NOTE_GLYPH_16055"] = "On top of a mountain"
	AL["NOTE_GLYPH_16056"] = "On top of a waterfall in the side of the mountain"
	AL["NOTE_GLYPH_16068"] = "On the air beside a big tree on top of a mountain"
	AL["NOTE_GLYPH_16069"] = "On the air on top of the tower"
	AL["NOTE_GLYPH_16064"] = "On the air on top of the tower"
	AL["NOTE_GLYPH_16071"] = "On the air between some big trees"
	AL["NOTE_GLYPH_16067"] = "On top of the highest tower"
	AL["NOTE_GLYPH_16072"] = "Inside the dome of the tower. There is a small entrance in one of the sides."
	AL["NOTE_GLYPH_16073"] = "On the air on top of the tower"
	AL["NOTE_GLYPH_16099"] = "On the highest peak of the mountain"
	AL["NOTE_GLYPH_16103"] = "On top of a floating rock"
	AL["NOTE_GLYPH_16104"] = "Inside the tower, under the dome"
	AL["NOTE_GLYPH_16101"] = "On top of the tower"
	AL["NOTE_GLYPH_16105"] = "Inside the tower, under the dome"
	AL["NOTE_377899"] = "Read the [Observant Riddles: A Field Guide]. In order to solve the riddle you have to gather three items ([Adventurer's Lost Soap Bar], [Marmoni's Prize] and [Well-Preserved Bone]) and merge them in front of the Field Guide."
	AL["NOTE_377899_1"] = "[Observant Riddles: A Field Guide]"
	AL["NOTE_377899_2"] = "[Adventurer's Lost Soap Bar]. Inside a tub of water."
	AL["NOTE_377899_3"] = "[Marmoni's Prize]. Inside a crate."
	AL["NOTE_377899_4"] = "[Well-Preserved Bone]. On the highest platform inside the tower, accesible from the top."
	AL["NOTE_193166"] = "Interact with it and [Shade of Grief] will spawn."
	AL["NOTE_187559"] = "Interact with [Solethus's Gravestone] to spawn this rare NPC."
	AL["NOTE_196010"] = "Inside a cave beside the base of the waterfall."
	AL["NOTE_193241"] = "Use the [Unstable time rift] to summon him."
	AL["NOTE_380991"] = "Click on [Ludo]. He will give you [Ludo's Stash Map]. Use it and then you will see the treasure."
	AL["NOTE_380991_1"] = "You can find [Ludo] here"
	AL["NOTE_380654"] = "Inside the tower, right on top of the ceiling above you if you access the main door. You will find it beside a sitting skeletor. Accesible flying from the top side of the tower."
	AL["CONTAINER_380991"] = "Slightly Chewed Duck Egg"
	AL["CONTAINER_380654"] = "Dead Man's Chestplate"
	AL["CONTAINER_195939"] = "Bubble Drifter"
	AL["CONTAINER_380653"] = "Yennu's Kite"
	AL["NOTE_380653"] = "Stuck in a branch of the tree."
	AL["NOTE_381110"] = "In order to see this treasure you have to find a [Sorrowful Letter]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_381158"] = "In order to see this treasure you have to find a [Letter of Caution]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_381223"] = "Inside a cave. In order to see this treasure you have to find a [Time-Lost Memo]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_377900"] = "In order to see this treasure you have to find [Nokhud Armorer's Notes]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_381153"] = "In order to see this treasure you have to find a [Ruby Gem Cluster Map]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_380847"] = "In order to see this treasure you have to find [Emerald Gardens Explorer's Notes]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_380867"] = "In order to see this treasure you have to find [Bear Termination Orders]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_381157"] = "In order to see this treasure you have to find [Precious Plans]. You can find this item in [Expedition Scout's Pack]s and [Disturbed Dirt]s."
	AL["NOTE_193254"] = "Only visible with the spell [Essence of Awakening] active"
	AL["NOTE_193254_1"] = "Essence of Awakening"
	AL["NOTE_381045"] = "In order to see this treasure you have to buy an [Archeologist Artifact Notes] to [Emilia Bellocq] and use it"
	AL["NOTE_381045_1"] = "Emilia Bellocq"
	AL["NOTE_193176"] = "Inside a cave. To enter you need to break a [Rock Wall] (requires Mining)."
	AL["NOTE_376175"] = "You need a [Fullsails Supply Chest Key] to open it. They key is dropped by nearby enemies."
	AL["NOTE_193688"] = "He is in one of the inner rings underground."
	AL["NOTE_193175"] = "In a cave accesible by the side of the mountain."
	AL["NOTE_193271"] = "In a cave."
	AL["NOTE_193132"] = "In a cave."
	AL["NOTE_DISTURBED_DIRT"] = "It can be found as soon as you reach renown 5 with the [Dragonscale Expedition]. To dig it you need 1x[Small Expedition Shovel] or 1x[Expedition Multi-Toolbox] bought from [Pathfinder Jeb] at the [Dragonscale Basecamp]"
	AL["NOTE_195939"] = "You need to find [A Guide to Rare Fish] (world drop) to be able to interact with it. Once you use that item, click on the [Fragant plant] and while the buff [Fragant Plant Scent] is active, interact with the [Bubble Drifter] in the water."
	AL["NOTE_195939_1"] = "Fragant plant"
	AL["NOTE_192983"] = "In the last chamber in a long cave."
	AL["NOTE_381107"] = "In order to see this treasure you have to collect [Yennu's Map] and use it."
	AL["NOTE_381107_1"] = "[Yennu's Map] is on the ground, beside [Yennu]"
	AL["NOTE_193196"] = "In order to summon him you have to find to [Olias Rivershaw] beside an [Uncharded Focus]. Then grab a [Humming Fragment] on the ground and use it to charge the [Uncharded Focus]."
	AL["NOTE_193196_1"] = "[Humming Fragment]"
	AL["NOTE_193196_2"] = "[Uncharded Focus]"
	AL["NOTE_193698"] = "In a cave."
	AL["NOTE_198004"] = "Inside the tree"
	AL["NOTE_196172"] = "Collect an [Acorn] from the ground to get the buff [Acorn]. While the buff is active, you can interact with the squirrel [Acorn Harvester]"
	AL["NOTE_377317"] = "Kill [Shimmermaw] and it will drop [Gilded key]. Use the key to open the treasure."
	AL["NOTE_191305"] = "You need to take a [Case of fresh Gleamfish] at [Azure Span] (show the guide icons to find it's position). Once you take it you have 15 minutes to bring it back to [Patient Vargoo] and he will start the event."
	AL["NOTE_191305_1"] = "[Patient Vargoo]"
	AL["NOTE_191305_2"] = "[Case of fresh Gleamfish]"
	AL["NOTE_STORM_EVENTS"] = "It only spawns while a storm event"
	AL["NOTE_193658"] = "A [Corrupted Dragon Egg] will appear in its position when it is ready to spawn. Interact with it to summon him."
	AL["NOTE_193128"] = "Talk to [Archaeologist Koranir] to start the combat"
	AL["NOTE_193231"] = "It spawns as soon as [Blightpaw the Deprave] is activated"
	AL["NOTE_193128_1"] = "[Archaeologist Koranir]"
	AL["NOTE_376587"] = "It can be found as soon as you reach renown 2 with the [Dragonscale Expedition]."
	AL["NOTE_380842"] = "Found inside a cave, on the ground beside a pile of gold."
	AL["NOTE_382325"] = "It is a reward for completing the quest [Rumors of the Jeweled Whelplings] that you will get once you reach renown 21 with the [Dragonscale Expedition]."
	AL["NOTE_195373"] = "Walk along the huge half-fallen tree to reach the tip and jump inside. There you will find a [Tree Sap], click on it to get the buff [Tree Sap] and while it is active, click on the [Stick] right on the tip of the tree (if you cannot click on it reload your interface). [Pepper Hammer] will appear and you can interact with it."
	AL["NOTE_195373_1"] = "[Tree Sap]"

	-- CONTINENT names
	AL["ZONES_CONTINENT_LIST"] = {
		[9999] = "Class Halls"; --Class Halls
		[9998] = "Darkmoon Island"; --Darkmoon Island
		[9997] = "Dungeons/Scenarios"; --Dungeons/Scenarios
		[9996] = "Raids"; --Raids
		[9995] = "Unknown"; --Unknown
		[9994] = "Expedition islands"; --Expedition islands
	}
end
