--- @class TalentViewer_NS
local _, ns = ...

ns.starterBuildID = Constants.TraitConsts.STARTER_BUILD_TRAIT_CONFIG_ID
ns.MAX_LEVEL_CLASS_CURRENCY_CAP = 31
ns.MAX_LEVEL_SPEC_CURRENCY_CAP = 30
ns.TOTAL_CURRENCY_CAP = ns.MAX_LEVEL_CLASS_CURRENCY_CAP + ns.MAX_LEVEL_SPEC_CURRENCY_CAP
ns.MAX_LEVEL = 9 + ns.TOTAL_CURRENCY_CAP

ns.data = {}
ns.data.classes = {
    { classId = 1, fileName = 'WARRIOR', iconId = 626008, defaultSpecId = 71 },
    { classId = 2, fileName = 'PALADIN', iconId = 626003, defaultSpecId = 70 },
    { classId = 3, fileName = 'HUNTER', iconId = 626000, defaultSpecId = 253 },
    { classId = 4, fileName = 'ROGUE', iconId = 626005, defaultSpecId = 259 },
    { classId = 5, fileName = 'PRIEST', iconId = 626004, defaultSpecId = 256 },
    { classId = 6, fileName = 'DEATHKNIGHT', iconId = 135771, defaultSpecId = 251 },
    { classId = 7, fileName = 'SHAMAN', iconId = 626006, defaultSpecId = 262 },
    { classId = 8, fileName = 'MAGE', iconId = 626001, defaultSpecId = 62 },
    { classId = 9, fileName = 'WARLOCK', iconId = 626007, defaultSpecId = 265 },
    { classId = 10, fileName = 'MONK', iconId = 626002, defaultSpecId = 268 },
    { classId = 11, fileName = 'DRUID', iconId = 625999, defaultSpecId = 102 },
    { classId = 12, fileName = 'DEMONHUNTER', iconId = 1260827, defaultSpecId = 577 },
    { classId = 13, fileName = 'EVOKER', iconId = 4574311, defaultSpecId = 1465 },
}
ns.data.specs = {
    { classId = 1, specId = 71, index = 0, specIconId = 132355 },
    { classId = 1, specId = 72, index = 1, specIconId = 132347 },
    { classId = 1, specId = 73, index = 2, specIconId = 132341 },
    { classId = 1, specId = 1446, index = 4, specIconId = 132355 },
    { classId = 2, specId = 65, index = 0, specIconId = 135920 },
    { classId = 2, specId = 66, index = 1, specIconId = 236264 },
    { classId = 2, specId = 70, index = 2, specIconId = 135873 },
    { classId = 2, specId = 1451, index = 4, specIconId = 135873 },
    { classId = 3, specId = 253, index = 0, specIconId = 461112 },
    { classId = 3, specId = 254, index = 1, specIconId = 236179 },
    { classId = 3, specId = 255, index = 2, specIconId = 461113 },
    { classId = 3, specId = 1448, index = 4, specIconId = 461112 },
    { classId = 4, specId = 259, index = 0, specIconId = 236270 },
    { classId = 4, specId = 260, index = 1, specIconId = 236286 },
    { classId = 4, specId = 261, index = 2, specIconId = 132320 },
    { classId = 4, specId = 1453, index = 4, specIconId = 236270 },
    { classId = 5, specId = 256, index = 0, specIconId = 135940 },
    { classId = 5, specId = 257, index = 1, specIconId = 237542 },
    { classId = 5, specId = 258, index = 2, specIconId = 136207 },
    { classId = 5, specId = 1452, index = 4, specIconId = 135940 },
    { classId = 6, specId = 250, index = 0, specIconId = 135770 },
    { classId = 6, specId = 251, index = 1, specIconId = 135773 },
    { classId = 6, specId = 252, index = 2, specIconId = 135775 },
    { classId = 6, specId = 1455, index = 4, specIconId = 135775 },
    { classId = 7, specId = 262, index = 0, specIconId = 136048 },
    { classId = 7, specId = 263, index = 1, specIconId = 237581 },
    { classId = 7, specId = 264, index = 2, specIconId = 136052 },
    { classId = 7, specId = 1444, index = 4, specIconId = 136048 },
    { classId = 8, specId = 62, index = 0, specIconId = 135932 },
    { classId = 8, specId = 63, index = 1, specIconId = 135810 },
    { classId = 8, specId = 64, index = 2, specIconId = 135846 },
    { classId = 8, specId = 1449, index = 4, specIconId = 135846 },
    { classId = 9, specId = 265, index = 0, specIconId = 136145 },
    { classId = 9, specId = 266, index = 1, specIconId = 136172 },
    { classId = 9, specId = 267, index = 2, specIconId = 136186 },
    { classId = 9, specId = 1454, index = 4, specIconId = 136145 },
    { classId = 10, specId = 268, index = 0, specIconId = 608951 },
    { classId = 10, specId = 270, index = 1, specIconId = 608952 },
    { classId = 10, specId = 269, index = 2, specIconId = 608953 },
    { classId = 10, specId = 1450, index = 4, specIconId = 608953 },
    { classId = 11, specId = 102, index = 0, specIconId = 136096 },
    { classId = 11, specId = 103, index = 1, specIconId = 132115 },
    { classId = 11, specId = 104, index = 2, specIconId = 132276 },
    { classId = 11, specId = 105, index = 3, specIconId = 136041 },
    { classId = 11, specId = 1447, index = 4, specIconId = 136096 },
    { classId = 12, specId = 577, index = 0, specIconId = 1247264 },
    { classId = 12, specId = 581, index = 1, specIconId = 1247265 },
    { classId = 12, specId = 1456, index = 4, specIconId = 1247264 },
    { classId = 13, specId = 1467, index = 0, specIconId = 4511811 },
    { classId = 13, specId = 1468, index = 1, specIconId = 4511812 },
    { classId = 13, specId = 1465, index = 4, specIconId = 4574311 },
}
